/*
 *  linux/drivers/mmc/mtk_msdc.h - Secure Digital Host Controller Interface driver
 *
 *  Copyright (C) 2009 Jethro Chang, All Rights Reserved.
 *
 */
#define MSDC_DESCRIPTER_DMA_ENABLE


 
#define MSDC_CARD_DETECT_PIN_CHECK
#define MSDC_SD_BUF_ALLOC_IN_SATA_BLTIN
//#define MSDC_POLLING_MICRO_SD_CARD
#define MSDC_WORKQUEUE_SUPPORT


#define SD_READ_ERROR_RETRY
#define SD_READ_ERROR_RETRY_CNT   4
#define SD_FORCE_REMOVE_RETRY_CNT   4

#define MSDC_LOG_ENABLE
//#define SD_CMD_DEBUG
#define MSDC_READ_WRITE_TEST
//#define MSDC_CRC_ERE_DECREASE_FREQ

/**
* Basic Type definition
*/

#define UINT32 uint32_t
#define UINT16 unsigned short
#define UINT8 unsigned char

#define INT32 int32_t
#define INT16 signed short
#define INT8 signed char

#define BOOL  int32_t

#define ASSERT(xxx)  assert(xxx)

#define VOID void

#define x_thread_delay(x)  udelay(x*3300);


//#define Printf  printk

#define UNUSED(x)               (void)x

#define x_sema_lock(x,y)  0

/**
* Host definition
*/
/*
struct __gpd_s__ {

	unsigned int hwo	:1;
	unsigned int bdp	:1;
	unsigned int resv0	:6;
	unsigned int chksum	:8;
	unsigned int intr	:1;
	unsigned int resv1	:15;

	void *pNext;
	void *pBuff;

	unsigned int buffLen:16;
	unsigned int extLen	:8;
	unsigned int resv3	:8;

	// Enhanced DMA fields
	unsigned int arg;
	unsigned int blkNum;
	unsigned int cmd;
}  __attribute ((packed));

typedef struct __gpd_s__ gpd_t;

struct __bd_s__ {
	
	unsigned int eol	:1;
	unsigned int resv0	:7;
	unsigned int chksum	:8;
	unsigned int resv1	:1;
	unsigned int blkPad	:1;
	unsigned int dwPad	:1;			// DWORD is 4 bytes
	unsigned int resv2	:13;

	void *pNext;
	void *pBuff;

	unsigned int buffLen:16;
	unsigned int resv3	:16;
}  __attribute ((packed));

typedef struct __bd_s__ bd_t;
*/


#define FCI_DMA_BUFFER_SIZE		          65536
#define FCI_DMA_BUFFER_SIZE_ORDER		4   // 2^4 * 4K = 64K bytes
#define FCI_BLOCK_SIZE  512

#define MSDC_SD_CMD_INIT    	  0
#define MSDC_SD_CMD_START	     1
#define MSDC_SD_CMD_END         2

struct mtk_msdc_host
{
	int         sdCmdState;                  /* Avoid double service command */

	// Current command & argument 
	UINT32  u4Cmd;
	UINT32  u4Arg;
	UINT32  u4CmdError;

//	int			flags;		/* Driver states */

	//int         fgPowerSwitchOn;    /* Power switch on status */
	//int         fgPowerSwitchTest;  /* Power switch on/off test */	
	//int         forceRemove;          /* force remove sd card or not */
	//int         forceRemoveCnt;     /* force remove counter */
	//int         fakeIns;                  /* Fake force insert */
	//unsigned int		card_type;		/* card type */
	
   unsigned int rreqcnt;              /* variable to store read count */
   unsigned int wreqcnt;              /* variable to store write count */
   
#define MSDC_FCARD_PRESENT	(1<<0)		/* Card is present */

	//unsigned int		offset;		/* Offset into current entry */
	//unsigned int		remain;		/* Data left in curren entry */

	unsigned int		clk;          		/* Current clock speed */
	unsigned char		bus_width;	/* Current bus width */
	int		             hispeedcard;          /* HiSpeed card or not */
   
	int			chip_id;	/* ID of controller */
	int			base;		/* I/O port base */
	int			irq;		    /* Interrupt irq number*/
	
};

