/********************************************************************************************
 *     LEGAL DISCLAIMER
 *
 *     (Header of MediaTek Software/Firmware Release or Documentation)
 *
 *     BY OPENING OR USING THIS FILE, BUYER HEREBY UNEQUIVOCALLY ACKNOWLEDGES AND AGREES
 *     THAT THE SOFTWARE/FIRMWARE AND ITS DOCUMENTATIONS ("MEDIATEK SOFTWARE") RECEIVED
 *     FROM MEDIATEK AND/OR ITS REPRESENTATIVES ARE PROVIDED TO BUYER ON AN "AS-IS" BASIS
 *     ONLY. MEDIATEK EXPRESSLY DISCLAIMS ANY AND ALL WARRANTIES, EXPRESS OR IMPLIED,
 *     INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR
 *     A PARTICULAR PURPOSE OR NONINFRINGEMENT. NEITHER DOES MEDIATEK PROVIDE ANY WARRANTY
 *     WHATSOEVER WITH RESPECT TO THE SOFTWARE OF ANY THIRD PARTY WHICH MAY BE USED BY,
 *     INCORPORATED IN, OR SUPPLIED WITH THE MEDIATEK SOFTWARE, AND BUYER AGREES TO LOOK
 *     ONLY TO SUCH THIRD PARTY FOR ANY WARRANTY CLAIM RELATING THERETO. MEDIATEK SHALL ALSO
 *     NOT BE RESPONSIBLE FOR ANY MEDIATEK SOFTWARE RELEASES MADE TO BUYER'S SPECIFICATION
 *     OR TO CONFORM TO A PARTICULAR STANDARD OR OPEN FORUM.
 *
 *     BUYER'S SOLE AND EXCLUSIVE REMEDY AND MEDIATEK'S ENTIRE AND CUMULATIVE LIABILITY WITH
 *     RESPECT TO THE MEDIATEK SOFTWARE RELEASED HEREUNDER WILL BE, AT MEDIATEK'S OPTION,
 *     TO REVISE OR REPLACE THE MEDIATEK SOFTWARE AT ISSUE, OR REFUND ANY SOFTWARE LICENSE
 *     FEES OR SERVICE CHARGE PAID BY BUYER TO MEDIATEK FOR SUCH MEDIATEK SOFTWARE AT ISSUE.
 *
 *     THE TRANSACTION CONTEMPLATED HEREUNDER SHALL BE CONSTRUED IN ACCORDANCE WITH THE LAWS
 *     OF THE STATE OF CALIFORNIA, USA, EXCLUDING ITS CONFLICT OF LAWS PRINCIPLES.
 ************************************************************************************************/

/** @file msdchw_reg.h
 *  MSDC module macro and constant declaration.
 */

#ifndef EMSDCHW_REG_H
#define EMSDCHW_REG_H

//---------------------------------------------------------------------------
// Include files
//---------------------------------------------------------------------------

//#include <../arch/arm/mach-mt85xx/include/mach/mt85xx_irqs_vector.h>

//---------------------------------------------------------------------------
// Chip definition
//---------------------------------------------------------------------------

#ifndef CONFIG_CHIP_VER_MT8560
#define CONFIG_CHIP_VER_MT8560 (8560)
#endif // #ifndef CONFIG_CHIP_VER_MT8560

#ifndef CONFIG_CHIP_VER_CURR
#define CONFIG_CHIP_VER_CURR  CONFIG_CHIP_VER_MT8560  // Default set as MT8560
#endif //#ifndef CONFIG_CHIP_VER_CURR

#if (CONFIG_CHIP_VER_CURR == CONFIG_CHIP_VER_MT8560)
#define E_SD_MLT_FNC_CFG 1
#define E_SD_PWR_CD_PIN_CFG 1
#define E_SD_WP_PIN_CFG 0
#endif

//---------------------------------------------------------------------------
// Type definitions
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
// Macro definitions
//---------------------------------------------------------------------------
#define EMSDC_WRITE32(addr, value)   (*(volatile unsigned int *)(addr)) = (value)
#define EMSDC_READ32(addr)              (*(volatile unsigned int *)(addr))

#define EMSDC_SETBIT(addr, dBit)        EMSDC_WRITE32(addr, EMSDC_READ32(addr) | (dBit))
#define EMSDC_CLRBIT(addr, dBit)        EMSDC_WRITE32(addr, EMSDC_READ32(addr) & (~(dBit)))

#define EMSDC_WAIT_SETBIT(addr, bit)\
            do{\
                EMSDC_SETBIT(addr, bit);\
                while(EMSDC_READ32(addr) & bit);\
		}while(0);

#define EMSDC_WAIT_BIT_CLR(addr, bit)\
            do{\
                EMSDC_CLRBIT(addr, bit);\
                while(!(EMSDC_READ32(addr)& bit));\
		}while(0);

//---------------------------------------------------------------------------
// Type definitions
//---------------------------------------------------------------------------
#define EMSDC_BASE_ADDR            (unsigned int) (EMMCIO_BASE)
#define EMSDC_VECTOR               (VECTOR_EMMC)

#define EMSDC_CH_NUM               (unsigned int) (1)
#define EMSDC_CH_OFFSET            (unsigned int) (0x00008000)

#define E_MSDC_CFG(ch)              (EMSDC_BASE_ADDR + (ch * EMSDC_CH_OFFSET) + 0x00)
#define E_MSDC_IOCON(ch)            (EMSDC_BASE_ADDR + (ch * EMSDC_CH_OFFSET) + 0x04)
#define E_MSDC_PS(ch)               (EMSDC_BASE_ADDR + (ch * EMSDC_CH_OFFSET) + 0x08)
#define E_MSDC_INT(ch)              (EMSDC_BASE_ADDR + (ch * EMSDC_CH_OFFSET) + 0x0C)
#define E_MSDC_INTEN(ch)            (EMSDC_BASE_ADDR + (ch * EMSDC_CH_OFFSET) + 0x10)
#define E_MSDC_FIFOCS(ch)           (EMSDC_BASE_ADDR + (ch * EMSDC_CH_OFFSET) + 0x14)
#define E_MSDC_TXDATA(ch)           (EMSDC_BASE_ADDR + (ch * EMSDC_CH_OFFSET) + 0x18)
#define E_MSDC_RXDATA(ch)           (EMSDC_BASE_ADDR + (ch * EMSDC_CH_OFFSET) + 0x1C)
#define E_SDC_CFG(ch)               (EMSDC_BASE_ADDR + (ch * EMSDC_CH_OFFSET) + 0x30)
#define E_SDC_CMD(ch)               (EMSDC_BASE_ADDR + (ch * EMSDC_CH_OFFSET) + 0x34)
#define E_SDC_ARG(ch)               (EMSDC_BASE_ADDR + (ch * EMSDC_CH_OFFSET) + 0x38)
#define E_SDC_STS(ch)               (EMSDC_BASE_ADDR + (ch * EMSDC_CH_OFFSET) + 0x3C)
#define E_SDC_RESP0(ch)             (EMSDC_BASE_ADDR + (ch * EMSDC_CH_OFFSET) + 0x40)
#define E_SDC_RESP1(ch)             (EMSDC_BASE_ADDR + (ch * EMSDC_CH_OFFSET) + 0x44)
#define E_SDC_RESP2(ch)             (EMSDC_BASE_ADDR + (ch * EMSDC_CH_OFFSET) + 0x48)
#define E_SDC_RESP3(ch)             (EMSDC_BASE_ADDR + (ch * EMSDC_CH_OFFSET) + 0x4C)
#define E_SDC_BLK_NUM(ch)           (EMSDC_BASE_ADDR + (ch * EMSDC_CH_OFFSET) + 0x50)
#define E_SDC_CSTS(ch)              (EMSDC_BASE_ADDR + (ch * EMSDC_CH_OFFSET) + 0x58)
#define E_SDC_CSTS_EN(ch)           (EMSDC_BASE_ADDR + (ch * EMSDC_CH_OFFSET) + 0x5C)
#define E_SDC_DATCRC_STS(ch)        (EMSDC_BASE_ADDR + (ch * EMSDC_CH_OFFSET) + 0x60)
#define E_EMMC_CFG0(ch)             (EMSDC_BASE_ADDR + (ch * EMSDC_CH_OFFSET) + 0x70)
#define E_EMMC_CFG1(ch)             (EMSDC_BASE_ADDR + (ch * EMSDC_CH_OFFSET) + 0x74)
#define E_EMMC_STS(ch)              (EMSDC_BASE_ADDR + (ch * EMSDC_CH_OFFSET) + 0x78)
#define E_EMMC_IOCON(ch)            (EMSDC_BASE_ADDR + (ch * EMSDC_CH_OFFSET) + 0x7C)
#define E_ACMD_RESP(ch)             (EMSDC_BASE_ADDR + (ch * EMSDC_CH_OFFSET) + 0x80)
#define E_ACMD19_TRG(ch)            (EMSDC_BASE_ADDR + (ch * EMSDC_CH_OFFSET) + 0x84)
#define E_ACMD19_STS(ch)            (EMSDC_BASE_ADDR + (ch * EMSDC_CH_OFFSET) + 0x88)
#define E_DMA_SA(ch)                (EMSDC_BASE_ADDR + (ch * EMSDC_CH_OFFSET) + 0x90)
#define E_DMA_CA(ch)                (EMSDC_BASE_ADDR + (ch * EMSDC_CH_OFFSET) + 0x94)
#define E_DMA_CTRL(ch)              (EMSDC_BASE_ADDR + (ch * EMSDC_CH_OFFSET) + 0x98)
#define E_DMA_CFG(ch)               (EMSDC_BASE_ADDR + (ch * EMSDC_CH_OFFSET) + 0x9C)
#define E_DBG_SEL(ch)               (EMSDC_BASE_ADDR + (ch * EMSDC_CH_OFFSET) + 0xA0)
#define E_DBG_OUT(ch)               (EMSDC_BASE_ADDR + (ch * EMSDC_CH_OFFSET) + 0xA4)
#define E_PATCH_BIT(ch)             (EMSDC_BASE_ADDR + (ch * EMSDC_CH_OFFSET) + 0xB0)
#define E_SD20_PAD_CTL0(ch)         (EMSDC_BASE_ADDR + (ch * EMSDC_CH_OFFSET) + 0xE0)
#define E_SD20_PAD_CTL1(ch)         (EMSDC_BASE_ADDR + (ch * EMSDC_CH_OFFSET) + 0xE4)
#define E_SD20_PAD_CTL2(ch)         (EMSDC_BASE_ADDR + (ch * EMSDC_CH_OFFSET) + 0xE8)
#define E_GPIO_DBG_OUT(ch)         (EMSDC_BASE_ADDR + (ch * EMSDC_CH_OFFSET) + 0xEB)
#define E_PAD_TUNE(ch)              (EMSDC_BASE_ADDR + (ch * EMSDC_CH_OFFSET) + 0xEC)
#define E_HW_DBG(ch)                (EMSDC_BASE_ADDR + (ch * EMSDC_CH_OFFSET) + 0xF8)
#define E_VERSION(ch)               (EMSDC_BASE_ADDR + (ch * EMSDC_CH_OFFSET) + 0xFC)

/* MSDC_CFG: 0x00 */
#define E_MSDC_CFG_SD                     ((UINT32)0x01 << 0)
#define E_MSDC_CFG_CK_PWD_EN                  ((UINT32)0x01 << 1)
#define E_MSDC_CFG_RST                    ((UINT32)0x01 << 2)
#define E_MSDC_CFG_PIO_MODE               ((UINT32)0x01 << 3)
#define E_MSDC_CFG_DMA_MODE               ((UINT32)0x00 << 3)
#define E_MSDC_CFG_CK_DRV_EN               ((UINT32)0x00 << 4)
#define E_MSDC_CFG_BUS_VOL_START          ((UINT32)0x01 << 5)
#define E_MSDC_CFG_BUS_VOL_PASS           ((UINT32)0x01 << 6)
#define E_MSDC_CFG_CARD_CK_STABLE         ((UINT32)0x01 << 7)
#define E_MSDC_CFG_CK_DIV_SHIFT           (8)
#define E_MSDC_CFG_CK_MODE_DIVIDER        ((UINT32)0x00 << 16)
#define E_MSDC_CFG_CK_MODE_DIRECT         ((UINT32)0x01 << 16)
#define E_MSDC_CFG_CK_MODE_DDR            ((UINT32)0x02 << 16)

/* MSDC_IOCON: 0x04 */
#define E_MSDC_IOCON_RISC_SIZE_MASK           ((UINT32)0x03 << 24)
#define E_MSDC_IOCON_RISC_SIZE_BYTE           ((UINT32)0x00 << 24)
#define E_MSDC_IOCON_RISC_SIZE_WORD          ((UINT32)0x01 << 24)
#define E_MSDC_IOCON_RISC_SIZE_DWRD           ((UINT32)0x02 << 24)

/* MSDC_INT: 0x0C  */
#define E_INT_MMC_IRQ                     ((UINT32)0x01 << 0)           
#define E_INT_MSDC_CDSC                   ((UINT32)0x01 << 1) 
#define E_INT_SD_AUTOCMD_RDY              ((UINT32)0x01 << 3) 
#define E_INT_SD_AUTOCMD_TO               ((UINT32)0x01 << 4) 
#define E_INT_SD_AUTOCMD_RESP_CRCERR      (0x01 << 5) 
#define E_INT_DMA_Q_EMPTY                 ((UINT32)0x01 << 6) 
#define E_INT_SD_SDIOIRQ                  ((UINT32)0x01 << 7) 
#define E_INT_SD_CMDRDY                   ((UINT32)0x01 << 8) 
#define E_INT_SD_CMDTO                    ((UINT32)0x01 << 9) 
#define E_INT_SD_RESP_CRCERR              ((UINT32)0x01 << 10)
#define E_INT_SD_CSTA                     ((UINT32)0x01 << 11)
#define E_INT_SD_XFER_COMPLETE            ((UINT32)0x01 << 12)
#define E_INT_DMA_XFER_DONE               ((UINT32)0x01 << 13)
#define E_INT_SD_DATTO                    ((UINT32)0x01 << 14)
#define E_INT_SD_DATA_CRCERR              ((UINT32)0x01 << 15)


#define E_INT_SD_ALL   (E_INT_SD_CMDRDY|E_INT_SD_CMDTO|\
                                E_INT_SD_RESP_CRCERR|E_INT_SD_XFER_COMPLETE| \
                                E_INT_DMA_XFER_DONE|E_INT_SD_DATTO|E_INT_SD_DATA_CRCERR)                               
#define E_INT_SD_DATA_STS  (E_INT_SD_XFER_COMPLETE|E_INT_DMA_XFER_DONE|E_INT_SD_DATTO|E_INT_SD_DATA_CRCERR)

#define E_INT_SD_CMD_STS   (E_INT_SD_CMDRDY|E_INT_SD_RESP_CRCERR|E_INT_SD_CMDTO)


/* SDC_CFG: 0x30  */
#define E_SDC_CFG_BW_SHIFT                (16)       
#define E_SDC_CFG_BW_1BIT                 ((UINT32)0x00 << E_SDC_CFG_BW_SHIFT)    
#define E_SDC_CFG_BW_4BIT                 ((UINT32)0x01 << E_SDC_CFG_BW_SHIFT)    
#define E_SDC_CFG_BW_8BIT                 ((UINT32)0x02 << E_SDC_CFG_BW_SHIFT)    
#define E_SDC_CFG_BW_MASK                 ((UINT32)0x03 << 16) 
#define E_SDC_CFG_SDIO                        ((UINT32)0x01 << 19) 
#define E_SDC_CFG_INTAT_BLK_GAP           ((UINT32)0x01 << 21) 
#define E_SDC_CFG_DTOC_SHIFT              (24)         
                                                     
/* SDC_STS: 0x3C  */                                 
#define E_SDC_STS_SDCBUSY                 ((UINT32)0x01<<0x0)  
#define E_SDC_STS_CMDBUSY                 ((UINT32)0x01<<0x1)  

/* SDC_CMD: 0x34  */                                        
#define E_SDC_CMD_BREAK                   ((UINT32)0x01 << 6)  
                                                     
#define E_SDC_CMD_RSPTYPE_NO              ((UINT32)0x00 << 7)  
#define E_SDC_CMD_RSPTYPE_R1              ((UINT32)0x01 << 7)  
#define E_SDC_CMD_RSPTYPE_R2              ((UINT32)0x02 << 7)  
#define E_SDC_CMD_RSPTYPE_R3              ((UINT32)0x03 << 7)  
#define E_SDC_CMD_RSPTYPE_R4              ((UINT32)0x04 << 7)  
#define E_SDC_CMD_RSPTYPE_R5              ((UINT32)0x01 << 7)  
#define E_SDC_CMD_RSPTYPE_R6              ((UINT32)0x01 << 7)  
#define E_SDC_CMD_RSPTYPE_R7              ((UINT32)0x01 << 7)  
#define E_SDC_CMD_RSPTYPE_R1B             ((UINT32)0x07 << 7)  
                                                     
#define E_DTYPE_NONE                      ((UINT32)0x00 << 11) 
#define E_DTYPE_SINGLE_BLK                ((UINT32)0x01 << 11) 
#define E_DTYPE_MULTI_BLK                 ((UINT32)0x02 << 11) 
#define E_DTYPE_STREAM                    ((UINT32)0x03 << 11) 
                                                     
#define E_SDC_CMD_READ                    ((UINT32)0x00 << 13) 
#define E_SDC_CMD_WRITE                   ((UINT32)0x01 << 13) 
                                                     
#define E_SDC_CMD_STOP                    ((UINT32)0x01 << 14) 
                                                     
#define E_SDC_CMD_GO_IRQ                  ((UINT32)0x01 << 15) 
                                                     
#define E_SDC_CMD_LEN_SHIFT               (16)         
                                                     
#define E_SDC_CMD_AUTO_CMD_NONE           ((UINT32)0x0 << 28)  
#define E_SDC_CMD_AUTO_CMD12              ((UINT32)0x1 << 28)  
#define E_SDC_CMD_ATUO_CMD23              ((UINT32)0x2 << 28)  
#define E_SDC_CMD_AUTO_CMD19              ((UINT32)0x3 << 28)  
                                                     
#define E_SDC_CMD_VOL_SWITCH              ((UINT32)0x1 << 30)  
                                                     
/* MSDC_FIFOCS: 0x14  */       
#define E_MSDC_FIFOCS_FIFOCLR              ((UINT32)0x1 << 31)                               
#define E_MSDC_FIFO_LEN                   (128)        
#define E_MSDC_FIFOCS_TXFIFOCNT_SHIFT     (16)     
#define E_MSDC_FIFOCS_TXFIFOCNT_MASK      (0x00FF0000)     
#define E_MSDC_FIFOCS_RXFIFOCNT_SHIFT     (0)          
#define E_MSDC_FIFOCS_RXFIFOCNT_MASK      (0x000000FF) 


/* DMA_CTRL: 0x98  */
#define E_DMA_CTRL_BST_SHIFT              (12)
#define E_DMA_CTRL_BST_8                  (3 << E_DMA_CTRL_BST_SHIFT)
#define E_DMA_CTRL_BST_16                 (4 << E_DMA_CTRL_BST_SHIFT)
#define E_DMA_CTRL_BST_32                 (5 << E_DMA_CTRL_BST_SHIFT)
#define E_DMA_CTRL_BST_64                 (6 << E_DMA_CTRL_BST_SHIFT)
#define E_DMA_CTRL_START                  ((UINT32)0x01 << 0)
#define E_DMA_CTRL_STOP                   ((UINT32)0x01 << 1)
#define E_DMA_CTRL_RESUME                 ((UINT32)0x01 << 2)
#define E_DMA_CTRL_LAST_BUF               ((UINT32)0x01 << 10)
#define E_DMA_CTRL_XFER_SIZE_SHIFT        (16)
#define E_DMA_CTRL_DESC_MODE              ((UINT32)0x01 << 8)


/* DMA_CFG: 0x9C  */
#define E_DMA_CFG_DMA_STATUS              ((UINT32)0x01 << 0)
#define E_DMA_CFG_CHKSUM                  ((UINT32)0x01 << 1)
#define E_DMA_CFG_BD_CS_ERR               ((UINT32)0x01 << 4)
#define E_DMA_CFG_GPD_CS_ERR              ((UINT32)0x01 << 5)

/* PATCH_BIT: 0xB0  */
#define E_R1B_DELAY_CYCLE              ((UINT32)0x0F << 18)

//---------------------------------------------------------------------------
// Inter-file functions
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
// Public functions
//---------------------------------------------------------------------------

#endif // MSDCHW_REG_H
