#include <mt85xx_gpio.h>
#include <asm/arch/x_typedef.h>

#ifndef _VFD_HW_H_
#define _VFD_HW_H_

/*----------------------------------------------------------------------------
 *---------------------------------------------------------------------------*/
#define	VFD_STB_OUT(fgFlag)  GPIO_Output(PIN_VFD_STB, fgFlag)

#define	VFD_CLK_OUT(fgFlag)  GPIO_Output(PIN_VFD_CLK, fgFlag)

#define	VFD_DATA_OUT(fgFlag)  GPIO_Config(PIN_LCDRD  ,OUTPUT,fgFlag)
                                  
#define	VFD_DATA_IN(bData)     GPIO_Config(PIN_VFD_DATA  ,INPUT,LOW); \
                                    bData = GPIO_Input(PIN_VFD_DATA)    

                            
 
/*----------------------------------------------------------------------------
 *---------------------------------------------------------------------------*/

#define vStbyVfdStrobe(fgFlag)  { \
   VFD_STB_OUT(fgFlag); \
   udelay(1);             \
}

#define vStbyVfdClk(fgFlag)  { \
   VFD_CLK_OUT(fgFlag); \
	udelay(1);			   \
} 

#define vStbyVfdData(fgFlag)  { \
   VFD_DATA_OUT(fgFlag); \
	udelay(1);			   \
} 

#define  vStbyVfdDataIn(bData)   { \   
   VFD_DATA_IN(bData); \
	udelay(1);			   \
}  

#define vStbyVfdCombineBit(bData) vStbyVfdData((bData & 0x1)); 

extern void vStbyVFDInit(void) ;
extern void vStbyVfdDirectClrAll(void) ;
extern void vStbyVfdDirectSetAll(void) ;
extern void vStbyVfdShowMsg(BYTE bMsgId, BOOL fgDirect) ;
extern void vStbyDelay(UINT32 wTicks);
extern void vStbyVfdKeyScan(void) ;

#endif
