/*
 *  
 *
 * Copyright (C) 2010 MediaTek Inc
 *
 *
 * 
 */

#ifndef __MT8560_GPIO_PINMUX_H
#define __MT8560_GPIO_PINMUX_H

// GPIO name definitions
#define PIN_GPIO2           2
#define PIN_GPIO3           3
#define PIN_GPIO4           4
#define PIN_GPIO5           5
#define PIN_GPIO6           6
#define PIN_GPIO7           7
#define PIN_AOLRCK          8
//#define PIN_AOMCLK          9
#define PIN_AOBCK           9
#define PIN_AOSDATA0        10
#define PIN_AOSDATA1        11
#define PIN_AOSDATA2        12
#define PIN_AOSDATA3        13
#define PIN_AOSDATA4        14
#define PIN_FECFREQ         15
#define PIN_FECMOD          16
#define PIN_FEDMO           17
#define PIN_FEEJECT         18
#define PIN_FEFG            19
#define PIN_FEFMO           20
#define PIN_FEFMO2          21    
#define PIN_FEFMO3          22   
#define PIN_FEFMO4          23
#define PIN_FEGAINSW1       24
#define PIN_FEGAINSW2       25
#define PIN_FEGAINSW3       26
#define PIN_FEGIO0          27     
#define PIN_FEGIO1          28
#define PIN_FEGIO10         29
#define PIN_FEGIO11         30
#define PIN_FEGIO3          31



#define PIN_FEGIO4          32
#define PIN_FEGIO5          33
#define PIN_FEGIO6          34 
#define PIN_FEGIO7          35
#define PIN_FEGIO9          36
#define PIN_FEOSCEN         37      
#define PIN_FETRAYIN        38
#define PIN_FETRAYOUT       39
#define PIN_FETRAYPWM       40 
#define PIN_NFALE           41
#define PIN_NFCEN           42
#define PIN_NFCEN2          43
#define PIN_NFCLE           44
#define PIN_NFD0            45
#define PIN_NFD1            46    
#define PIN_NFD2            47
#define PIN_NFD3            48     
#define PIN_NFD4            49
#define PIN_NFD5            50    
#define PIN_NFD6            51
#define PIN_NFD7            52
#define PIN_NFRBN           53
#define PIN_NFRBN2          54
#define PIN_NFREN           55
#define PIN_NFWEN           56
#define PIN_SCL             57
#define PIN_SDA             58
#define PIN_SPDIF           59
#define PIN_VOUTCLK         60
#define PIN_VOUTD0          61
#define PIN_VOUTD1          62
#define PIN_VOUTD10         63


#define PIN_VOUTD11         64
#define PIN_VOUTD12         65
#define PIN_VOUTD13         66
#define PIN_VOUTD14         67
#define PIN_VOUTD15         68
#define PIN_VOUTD2          69
#define PIN_VOUTD3          70
#define PIN_VOUTD4          71
#define PIN_VOUTD5          72
#define PIN_VOUTD6          73
#define PIN_VOUTD7          74            
#define PIN_VOUTD8          75
#define PIN_VOUTD9          76
#define PIN_VOUTHSYNC       77
#define PIN_VOUTVSYNC       78
#define PIN_AMUTE           79
//#define PIN_AOBCK           80
#define PIN_AOMCLK          80
#define PIN_USB_DP_P0       81
#define PIN_USB_DM_P0       82
#define PIN_USB_DP_P1       83
#define PIN_USB_DM_P1       84
#define PIN_USB_DP_P2       85
#define PIN_USB_DM_P2       86


#define PIN_VFD_STB         87
#define PIN_VFD_CLK         88 
#define PIN_VFD_DATA        89
#define PIN_LCDRD           90

#define PIN_GPIO0           94
#define PIN_GPIO1           95

#define PIN_HDMI_SCK        110
#define PIN_HDMI_SD         111
#define PIN_HDMI_HTPLG      112
#define PIN_HDMI_CEC        113 
//#define PIN_UATXD           113
  
#define PIN_UNKNOWN         255

// Total GPIO is 173.
#define TOTAL_GPIO_NUM      113


//8560 Pin mux function definitions
#define AUD_MCLK_SEL            0
#define SEL_AOMCLK              0
#define SEL_AOBCK               0
#define SEL_AOLRCK              0

#define AUD_LINDATA_SEL         2
#define SEL_LINDATA             2

#define AUD_AMUTE2_SEL          4
#define SEL_AMUTE2              4

#define AUD_SDATA0_SEL          6
#define SEL_AOSDATA0            6

#define AUD_SDATA1_SEL          7
#define SEL_AOSDATA1            7

#define AUD_SDATA2_SEL          8
#define SEL_AOSDATA2            8

#define AUD_SDATA3_SEL          9
#define SEL_AOSDATA3            9

#define AUD_SDATA4_SEL          10
#define SEL_AOSDATA4            10

#define AUD_AMUTE_SEL           11
#define SEL_AMUTE               11

#define AUD_MCIN_SEL            12
#define SEL_MCIN                12

#define AUD_SPDIF_SEL           14 
#define SEL_SPDIF               14

#define AUD_SPDATA_SEL          15 
#define SEL_SPDATA0             15

#define AUD_SPLRCK_SEL          18
#define SEL_SPLRCK              18

#define AUD_SPBCK_SEL           19
#define SEL_SPBCK               19

#define AUD_SPMCLK_SEL          20
#define SEL_SPMCLK              20

#define FESF_SEL                21
#define SEL_FESF                21

#define I2C_SEL                 22
#define SEL_SCL                 22 
#define SEL_SDA                 22

#define EXT_INTR4_SEL           23
#define SEL_EXT_INTR4           23

#define FEJTAG_SEL              27
#define SEL_FE_JTDO             27
#define SEL_FE_JTCLK            27
#define SEL_FE_JTMS             27
#define SEL_FE_JTDI             27
#define SEL_FE_JTRST_B          27
#define SEL_FE_JRTCLK           27

#define FELVDS_SEL              29
#define SEL_LVDS1P              29
#define SEL_LVDS1N              29
#define SEL_LVDS2P              29
#define SEL_LVDS2N              29
#define SEL_LVDS3P              29
#define SEL_LVDS3N              29
#define SEL_LVDS4P              29
#define SEL_LVDS4N              29
#define SEL_LVDS5P              29
#define SEL_LVDS5N              29

#define NAND_SEL                30
#define SEL_NFREN               30
#define SEL_NFCLE               30 
#define SEL_NFCEN               30 
#define SEL_NFWEN               30
#define SEL_NFALE               30
#define SEL_NFRBN               30
#define SEL_NFD0                30
#define SEL_NFD1                30
#define SEL_NFD2                30
#define SEL_NFD3                30
#define SEL_NFD4                30
#define SEL_NFD5                30
#define SEL_NFD6                30
#define SEL_NFD7                30

#define NAND_RDY2_SEL           31
#define SEL_NFRBN2              31 




#define VOUTCLK_SEL             32 
#define SEL_VOUTCLK             32

#define VOUTHSYNC_SEL           33
#define SEL_VOUTHSYNC           33 

#define VOUTVSYNC_SEL           34
#define SEL_VOUTVSYNC           34

#define VOUTD0_1_SEL            35 
#define SEL_VOUTD0              35
#define SEL_VOUTD1              35

#define VOUTD2_7_SEL            36
#define SEL_VOUTD2              36
#define SEL_VOUTD3              36
#define SEL_VOUTD4              36
#define SEL_VOUTD5              36
#define SEL_VOUTD6              36
#define SEL_VOUTD7              36

#define VOUTD8_9_SEL            37
#define SEL_VOUTD8              37
#define SEL_VOUTD9              37

#define VOUTD10_11_SEL          38
#define SEL_VOUTD10             38
#define SEL_VOUTD11             38

#define VOUTD12_15_SEL          39
#define SEL_VOUTD12             39
#define SEL_VOUTD13             39
#define SEL_VOUTD14             39
#define SEL_VOUTD15             39

#define VOUTDE_SEL              40
#define SEL_VOUTDE              40

#define VOUTDSEL0               43
#define SEL_VOUT_SEL_0          43

#define VOUTDSEL1               44
#define SEL_VOUT_SEL_1          44


#define SD_SEL                  48
#define SEL_MSDC_IO_SEL         48

#define TEST_VDAC               49
#define SEL_TEST_VDAC_SEL       49

#define AMUTE_OUT_INV           50
#define SEL_AMUTE_INV_SEL       50

#define JTAG_SEL                52
#define SEL_TDO                 52
#define SEL_TCK                 52
#define SEL_TMS                 52
#define SEL_TDI                 52

#define MII_SEL                 58
#define SEL_TXCLK               58
#define SEL_RXCLK               58
#define SEL_MDIO                58
#define SEL_COL                 58
#define SEL_RXDV                58
#define SEL_RXD0                58
#define SEL_RXD1                58
#define SEL_RXD2                58
#define SEL_RXD3                58
#define SEL_RXER                58
#define SEL_TXEN                58
#define SEL_TXD0                58
#define SEL_TXD1                58
#define SEL_TXD2                58
#define SEL_TXD3                58
#define SEL_TXER                58
#define SEL_MDC                 58

#define PD_RS232_SEL            59 
#define SEL_UATXD1              59
#define SEL_UARXD1              59



#define NAND_CEN2_SEL           64
#define SEL_NFCEN2              64 

#define EXT_INTR1_SEL           76
#define SEL_EXT_INTR1           76

#define EXT_INTR2_SEL           80
#define SEL_EXT_INTR2           80

#define RS232_D3_SEL            84
#define SEL_UATXD3              84
#define SEL_UARXD3              84

#define SI2C_SEL                88 
#define SEL_SCLS                88 
#define SEL_SDAS                88

#define RS232_D2_SEL            92 
#define SEL_UATXD2              92
#define SEL_UARXD2              92

#define TEST_IN_SEL             99 
#define SEL_TIND31              99
#define SEL_TIND30              99 
#define SEL_TIND29              99
#define SEL_TIND28              99
#define SEL_TIND27              99
#define SEL_TIND26              99
#define SEL_TIND25              99
#define SEL_TIND24              99
#define SEL_TIND23              99
#define SEL_TIND22              99
#define SEL_TIND21              99
#define SEL_TIND20              99
#define SEL_TIND19              99
#define SEL_TIND18              99
#define SEL_TIND17              99
#define SEL_TIND16              99
#define SEL_TIND15              99
#define SEL_TIND14              99
#define SEL_TIND13              99
#define SEL_TIND12              99
#define SEL_TIND11              99
#define SEL_TIND10              99
#define SEL_TIND9               99
#define SEL_TIND8               99
#define SEL_TIND7               99
#define SEL_TIND6               99
#define SEL_TIND5               99
#define SEL_TIND4               99
#define SEL_TIND3               99
#define SEL_TIND2               99
#define SEL_TIND1               99
#define SEL_TIND0               99

#define MONITOR_SEL             100 
#define SEL_MOUTB31             100
#define SEL_MOUTB30             100
#define SEL_MOUTB29             100
#define SEL_MOUTB28             100
#define SEL_MOUTB27             100
#define SEL_MOUTB26             100
#define SEL_MOUTB25             100
#define SEL_MOUTB24             100
#define SEL_MOUTB23             100
#define SEL_MOUTB22             100
#define SEL_MOUTB21             100
#define SEL_MOUTB20             100
#define SEL_MOUTB19             100
#define SEL_MOUTB18             100
#define SEL_MOUTB17             100
#define SEL_MOUTB16             100
#define SEL_MOUTB15             100
#define SEL_MOUTB14             100
#define SEL_MOUTB13             100
#define SEL_MOUTB12             100
#define SEL_MOUTB11             100
#define SEL_MOUTB10             100
#define SEL_MOUTB9              100
#define SEL_MOUTB8              100
#define SEL_MOUTB7              100
#define SEL_MOUTB6              100
#define SEL_MOUTB5              100
#define SEL_MOUTB4              100
#define SEL_MOUTB3              100
#define SEL_MOUTB2              100
#define SEL_MOUTB1              100
#define SEL_MOUTB0              100

#define AOMCLK_PWM_SEL          104      
#define SEL_AOMCLK_PWM          104

#define AOBCK_PWM_SEL           105  
#define SEL_AOBCK_PWM           105

#define EFVDDQ_SEL              124
#define SEL_EFVDDQ              124

#define EFSRC_SEL               125 
#define SEL_EFSRC               125

#define MONITOR_MODE_SEL        128
#define SEL_MONITOR_MODE        128

#define MONITOR_DRAM_SEL        136        
#define SEL_MONITOR_DRAM        136

#define PWM_SEL                 152
#define SEL_PWM                 152




#define HDMI_TST_SEL            161 
#define SEL_HDMI_TST            161

#define EXT_ACLK_SEL            168
#define SEL_APLL_CLK            168

#define USB_I2C_SEL             170
#define SEL_I2C_SCL             170
#define SEL_I2C_SDA             170

#define MCIN_MPMCLK_SEL         175
#define SEL_MCIN_MPMCLK         175

#define MCIN_MPBCK_SEL          178 
#define SEL_MCIN_MPBCK          178

#define MCIN_MPLRCK_SEL         181 
#define SEL_MCIN_MPLRCK         181

#define DCKINV_SEL              190
#define SEL_DCKINV_SEL          190





#define PROT_SEL                192 
#define SEL_PROT                192





#define FEDIGITAL_0_SEL         224 
#define SEL_FEDIGITAL_0         224

#define FEDIGITAL_1_SEL         225 
#define SEL_FEDIGITAL_1         225


#define FEDIGITAL_3_SEL         227 
#define SEL_FEDIGITAL_3         227

#define FEDIGITAL_4_SEL         228 
#define SEL_FEDIGITAL_4         228

#define FEDIGITAL_5_SEL         229 
#define SEL_FEDIGITAL_5         229

#define FEDIGITAL_6_SEL         230 
#define SEL_FEDIGITAL_6         230

#define FEDIGITAL_7_SEL         231 
#define SEL_FEDIGITAL_7         231

#define FEDIGITAL_9_SEL         233 
#define SEL_FEDIGITAL_9         233

#define FEDIGITAL_10_SEL         234 
#define SEL_FEDIGITAL_10         234

#define FEDIGITAL_11_SEL         235 
#define SEL_FEDIGITAL_11         235

#define FEDIGITAL_14_SEL         238 
#define SEL_FEDIGITAL_14         238

#define FEDIGITAL_15_SEL         239 
#define SEL_FEDIGITAL_15         239

#define FEDIGITAL_17_SEL         241 
#define SEL_FEDIGITAL_17         241

#define FEDIGITAL_18_SEL         242 
#define SEL_FEDIGITAL_18         242

#define FEDIGITAL_20_SEL         244 
#define SEL_FEDIGITAL_20         244

#define FEDIGITAL_21_SEL         245 
#define SEL_FEDIGITAL_21         245

#define FEDIGITAL_22_SEL         246 
#define SEL_FEDIGITAL_22         246

#define FEDIGITAL_23_SEL         247 
#define SEL_FEDIGITAL_23         247

#define FEDIGITAL_24_SEL         248 
#define SEL_FEDIGITAL_24         248

#define FEDIGITAL_25_SEL         249 
#define SEL_FEDIGITAL_25         249

#define FEDIGITAL_26_SEL         250 
#define SEL_FEDIGITAL_26         250

#define FEDIGITAL_27_SEL         251 
#define SEL_FEDIGITAL_27         251

#define FEDIGITAL_28_SEL         252 
#define SEL_FEDIGITAL_28         252

#define FEDIGITAL_29_SEL         253 
#define SEL_FEDIGITAL_29         253

#define FEDIGITAL_30_SEL         254 
#define SEL_FEDIGITAL_30         254

#define FEDIGITAL_31_SEL         255 
#define SEL_FEDIGITAL_31         255


//PAD_FECTL @ 0X280~0X284
#define SEL_FECTL_0             256
#define SEL_FECTL_1             257
#define SEL_FECTL_2             258
#define SEL_FECTL_3             259
#define SEL_FECTL_4             260
#define SEL_FECTL_5             261
#define SEL_FECTL_6             262
#define SEL_FECTL_7             263
#define SEL_FECTL_8             264
#define SEL_FECTL_9             265
#define SEL_FECTL_10             266
#define SEL_FECTL_11             267
#define SEL_FECTL_12             268
#define SEL_FECTL_13             269
#define SEL_FECTL_14             270
#define SEL_FECTL_15             271
#define SEL_FECTL_16             272
#define SEL_FECTL_17             273
#define SEL_FECTL_18             274
#define SEL_FECTL_19             275
#define SEL_FECTL_20             276
#define SEL_FECTL_21             277
#define SEL_FECTL_22             278
#define SEL_FECTL_23             279
#define SEL_FECTL_24             280
#define SEL_FECTL_25             281
#define SEL_FECTL_26             282
#define SEL_FECTL_27             283
#define SEL_FECTL_28             284
#define SEL_FECTL_29             285
#define SEL_FECTL_30             286
#define SEL_FECTL_31             287
#define SEL_FECTL_32             288
#define SEL_FECTL_33             289
#define SEL_FECTL_34             290

//PAD_PWMCTL @ 0X288
#define ETLED_0_SEL             310 //272
#define SEL_ETLED_0             310 //272

#define ETLED_1_SEL             314 //276
#define SEL_ETLED_1             314 //276

#define ETLED_2_SEL             318 //280 
#define SEL_ETLED_2             318 //280

#define ETLED_3_SEL             322 //284 
#define SEL_ETLED_3             322 //284


#define MAX_PINMUX_SEL          325 //287

#if 0
//PAD_PWMCTL @ 0X288
#define ETLED_0_SEL             272
#define SEL_ETLED_0             272

#define ETLED_1_SEL             276
#define SEL_ETLED_1             276

#define ETLED_2_SEL             280 
#define SEL_ETLED_2             280

#define ETLED_3_SEL             284 
#define SEL_ETLED_3             284


#define MAX_PINMUX_SEL          287
#endif


#endif /* __MT8560_GPIO_PINMUX_H */

