/*
 * arch/arm/mach-mt85xx/include/mach/mt8555_gpio_pinmux.h
 *
 * Copyright (C) 2010 MediaTek Inc
 *
 *
 */

#ifndef __MT8580_GPIO_PINMUX_H
#define __MT8580_GPIO_PINMUX_H

// GPIO name definitions
#define PIN_GPIO0             0
#define PIN_GPIO1            1
#define PIN_GPIO2            2
#define PIN_GPIO3           3
#define PIN_GPIO4            4
#define PIN_GPIO5          5
#define PIN_GPIO6           6
#define PIN_GPIO7            7
#define PIN_GPIO8           8
#define PIN_GPIO9          9
#define PIN_GPIO10        10
#define PIN_GPIO11          11
#define PIN_GPIO12        12
#define PIN_GPIO13       13
#define PIN_GPIO14      14
#define PIN_GPIO15       15
#define PIN_GPIO16       16
#define PIN_GPIO17      17
#define PIN_GPIO18           18
#define PIN_GPIO19         19
#define PIN_GPIO20            20
#define PIN_GPIO21           21
#define PIN_GPIO22          22
#define PIN_GPIO23          23
#define PIN_GPIO24          24
#define PIN_GPIO25       25
#define PIN_GPIO26       26
#define PIN_GPIO27       27
#define PIN_AL0          28
#define PIN_AMUTE          29
#define PIN_AOBCK          30
#define PIN_AOLRCK          31

#define PIN_AOMCLK          32
#define PIN_AOSDATA0           33
#define PIN_AOSDATA1           34
#define PIN_AOSDATA2          35
#define PIN_AOSDATA3          36
#define PIN_AOSDATA4         37
#define PIN_AR0            38
#define PIN_ARC           39
#define PIN_CEC2          40
#define PIN_COAXIAL           41
#define PIN_DDC_SCL_RX2            42
#define PIN_DDC_SDA_RX2           43
#define PIN_FECFREQ           44
#define PIN_FECMOD           45
#define PIN_FEDMO          46
#define PIN_FEEJECT          47
#define PIN_FEFG          48
#define PIN_FEFMO           49
#define PIN_FEFMO2          50
#define PIN_FEFMO3           51
#define PIN_FEFMO4           52
#define PIN_FEGAINSW1           53
#define PIN_FEGAINSW2          54
#define PIN_FEGAINSW3          55
#define PIN_FEGIO0          56
#define PIN_FEGIO1          57
#define PIN_FEGIO10           58
#define PIN_FEGIO11           59
#define PIN_FEGIO3           60
#define PIN_FEGIO4           61
#define PIN_FEGIO5            62
#define PIN_FEGIO6            63
#define PIN_FEGIO7           64
#define PIN_FEGIO9            65
#define PIN_FEOSCEN           66
#define PIN_FETRAYIN           67
#define PIN_FETRAYOUT           68
#define PIN_FETRAYPWM         69
#define PIN_HTPLG_RX       70
#define PIN_HTPLG_RX2            71
#define PIN_MCIN             72
#define PIN_MDC             73
#define PIN_MDIO            74
#define PIN_NFALE           75
#define PIN_NFCEN           76
#define PIN_NFCEN2          77
#define PIN_NFCLE           78
#define PIN_NFD0            79
#define PIN_NFD1            80
#define PIN_NFD2            81
#define PIN_NFD3            82
#define PIN_NFD4            83
#define PIN_NFD5            84
#define PIN_NFD6            85
#define PIN_NFD7            86
#define PIN_NFRBN           87
#define PIN_NFRBN2          88
#define PIN_NFREN           89
#define PIN_NFWEN           90
#define PIN_OPTICAL         91
#define PIN_PWR5V_RX2       92
#define PIN_SCL             93
#define PIN_SDA             94
#define PIN_SPDATA          95
#define PIN_SPDIF           96

#define PIN_VOUTCLK         97
#define PIN_VOUTD0          98
#define PIN_VOUTD1          99
#define PIN_VOUTD10         100
#define PIN_VOUTD11         101
#define PIN_VOUTD12         102
#define PIN_VOUTD13         103
#define PIN_VOUTD14         104
#define PIN_VOUTD15         105
#define PIN_VOUTD2          106
#define PIN_VOUTD3          107
#define PIN_VOUTD4          108
#define PIN_VOUTD5          109
#define PIN_VOUTD6          110
#define PIN_VOUTD7          111
#define PIN_VOUTD8          112
#define PIN_VOUTD9          113
#define PIN_VOUTHSYNC       114
#define PIN_VOUTVSYNC       115
#define PIN_USB_DP_P0       116
#define PIN_USB_DM_P0       117
#define PIN_USB_DP_P1       118
#define PIN_USB_DM_P1       119
#define PIN_USB_DP_P2       120
#define PIN_USB_DM_P2       121


#define PIN_VFD_STB         122
#define PIN_VFD_CLK         123 
#define PIN_VFD_DATA        124
#define PIN_LCDRD           125

#define PIN_HDMI_SCK        145
#define PIN_HDMI_SD         146
#define PIN_HDMI_HTPLG      147
#define PIN_HDMI_CEC        148 

#define PIN_DDC_SCL_RX      149
#define PIN_DDC_SDA_RX      150
#define PIN_PWR5V_RX        151






#define PIN_UNKNOWN         255

// Total GPIO is 125.
#define TOTAL_GPIO_NUM      151


//8580 Pin mux function definitions
#define AUD_MCLK_SEL            0
#define SEL_AOMCLK              0
#define SEL_AOBCK               0
#define SEL_AOLRCK              0

#define AUD_AMUTE2_SEL          2
#define SEL_AUD_AMUTE2         2

#define AUD_SDATA0_SEL          6
#define SEL_AOSDATA0            6

#define AUD_SDATA1_SEL          7
#define SEL_AOSDATA1            7

#define AUD_SDATA2_SEL          8
#define SEL_AOSDATA2            8

#define AUD_SDATA3_SEL          9
#define SEL_AOSDATA3            9

#define AUD_AMUTE_SEL           12
#define SEL_AMUTE               12

#define AUD_SPDIF_SEL           14
#define SEL_SPDIF               14

#define AUD_SPDATA_SEL          15
#define SEL_SPDATA              15

#define NAND_RDY2_SEL           16
#define SEL_NAND_RDY2           16

#define AUD_SPLRCK_SEL          18
#define SEL_SPLRCK              18

#define AUD_SPMCLK_SEL          20
#define SEL_SPMCLK              20

#define FESF_SEL                21
#define SEL_FESF                21

#define EXT_INTR4_SEL           23
#define SEL_EXT_INTR4           23


#define FEJTAG_SEL              27
#define SEL_FE_JTDO             27
#define SEL_FE_JTCLK            27
#define SEL_FE_JTMS             27
#define SEL_FE_JTDI             27
#define SEL_FE_JTRST_B          27
#define SEL_FE_JRTCLK           27

#define FELVDS_SEL              29
#define SEL_LVDS1P              29
#define SEL_LVDS1N              29
#define SEL_LVDS2P              29
#define SEL_LVDS2N              29
#define SEL_LVDS3P              29
#define SEL_LVDS3N              29
#define SEL_LVDS4P              29
#define SEL_LVDS4N              29
#define SEL_LVDS5P              29
#define SEL_LVDS5N              29

#define NAND_SEL                30
#define SEL_NFREN               30
#define SEL_NFCLE               30
#define SEL_NFCEN               30
#define SEL_NFWEN               30
#define SEL_NFALE               30
#define SEL_NFRBN               30
#define SEL_NFD0                30
#define SEL_NFD1                30
#define SEL_NFD2                30
#define SEL_NFD3                30
#define SEL_NFD4                30
#define SEL_NFD5                30
#define SEL_NFD6                30
#define SEL_NFD7                30

#define EXT_SF_SCK_SEL          32
#define SEL_EXT_SF_SCK          32

#define SD_SEL                  34
#define SEL_MSDC                34

#define TEST_VDAC_SEL           35
#define SEL_TEST_VDAC           35

#define AMUTE_OUT_INV_SEL       36
#define SEL_AMUTE_INVERT        36

#define AUD_LINDATA_SEL         37
#define SEL_AUD_LINDATA         37

#define AUD_MCIN_SEL            39
#define SEL_AUD_MCIN            39

#define AUD_SPBCK_SEL           41
#define SEL_AUD_SPBCK           41

#define EXT_SF_CS_SEL           43
#define SEL_EXT_SF_CS           43

#define JTAG_SEL                46
#define SEL_TDO                 46
#define SEL_TCK                 46
#define SEL_TMS                 46
#define SEL_TDI                 46

#define AUD_SDATA5_SEL          49
#define SEL_AOSDATA5            49

#define M27_OUT_SEL             52
#define SEL_MJC                 52

#define AUD_SDATA4_SEL          60
#define SEL_AOSDATA4            60

#define NAND_CEN2_SEL           64
#define SEL_NFCEN2              64

#define NAND_CEN3_SEL           68
#define SEL_NFCEN3              68

#define NAND_CEN4_SEL           72
#define SEL_NFCEN4              72

#define EXT_INTR1_SEL           76
#define SEL_EXT_INTR1           76

#define EXT_INTR2_SEL           80
#define SEL_EXT_INTR2           80

#define SIM_CARD_SEL           84
#define SEL_SIM_CARD           84

#define SI2C_SEL                88
#define SEL_SCLS                88
#define SEL_SDAS                88

#define I2C_SEL                93
#define SEL_SCL                93
#define SEL_SDA                93

#define TEST_IN_SEL             99
#define SEL_TIND31              99
#define SEL_TIND30              99
#define SEL_TIND29              99
#define SEL_TIND28              99
#define SEL_TIND27              99
#define SEL_TIND26              99
#define SEL_TIND25              99
#define SEL_TIND24              99
#define SEL_TIND23              99
#define SEL_TIND22              99
#define SEL_TIND21              99
#define SEL_TIND20              99
#define SEL_TIND19              99
#define SEL_TIND18              99
#define SEL_TIND17              99
#define SEL_TIND16              99
#define SEL_TIND15              99
#define SEL_TIND14              99
#define SEL_TIND13              99
#define SEL_TIND12              99
#define SEL_TIND11              99
#define SEL_TIND10              99
#define SEL_TIND9               99
#define SEL_TIND8               99
#define SEL_TIND7               99
#define SEL_TIND6               99
#define SEL_TIND5               99
#define SEL_TIND4               99
#define SEL_TIND3               99
#define SEL_TIND2               99
#define SEL_TIND1               99
#define SEL_TIND0               99

#define MONITOR_SEL             100
#define SEL_MOUTB31             100
#define SEL_MOUTB30             100
#define SEL_MOUTB29             100
#define SEL_MOUTB28             100
#define SEL_MOUTB27             100
#define SEL_MOUTB26             100
#define SEL_MOUTB25             100
#define SEL_MOUTB24             100
#define SEL_MOUTB23             100
#define SEL_MOUTB22             100
#define SEL_MOUTB21             100
#define SEL_MOUTB20             100
#define SEL_MOUTB19             100
#define SEL_MOUTB18             100
#define SEL_MOUTB17             100
#define SEL_MOUTB16             100
#define SEL_MOUTB15             100
#define SEL_MOUTB14             100
#define SEL_MOUTB13             100
#define SEL_MOUTB12             100
#define SEL_MOUTB11             100
#define SEL_MOUTB10             100
#define SEL_MOUTB9              100
#define SEL_MOUTB8              100
#define SEL_MOUTB7              100
#define SEL_MOUTB6              100
#define SEL_MOUTB5              100
#define SEL_MOUTB4              100
#define SEL_MOUTB3              100
#define SEL_MOUTB2              100
#define SEL_MOUTB1              100
#define SEL_MOUTB0              100

#define AOMCLK_PWM_SEL          104
#define SEL_AOMCLK_PWM          104

#define AOBCK_PWM_SEL           105
#define SEL_AOBCK_PWM           105

#define HDMI_RX_SEL             108
#define SEL_HDMI_RX             108

#define HDMI_RX_SPDF_SEL        109
#define SEL_HDMI_RX_SPDF        109

#define HDMI_RX_ACK_SEL         110
#define SEL_HDMI_RX_ACK         110

#define HDMI_EXT_DATA_SEL       114
#define SEL_HDMI_EXT_DATA       114

#define HDMI_EXT_DSD_SEL        115
#define SEL_HDMI_EXT_DSD        115

#define HDMI_EXT_SPDF_SEL       116
#define SEL_HDMI_EXT_SPDF       116

#define HDMI_EXT_ACK_SEL        117
#define SEL_HDMI_EXT_ACK        117

#define HDMI_EXT_BCK_SEL        118
#define SEL_HDMI_EXT_BCK        118

#define HDMI_EXT_LRCK_SEL       119
#define SEL_HDMI_EXT_LRCK       119

#define HDMI_RX_SDATA0_SEL      120
#define SEL_HDMI_RX_SDATA0      120

#define HDMI_EXT_RX_SPDF_SEL    121
#define SEL_HDMI_EXT_RX_SPDF    121

#define EFVDDQ_SEL              124
#define SEL_EFVDDQ              124

#define EFSRC_SEL               125
#define SEL_EFSRC               125

#define RTC_TST_SEL               126
#define SEL_RTC_TST               126

#define WAVEOUT_SEL               127
#define SEL_WAVEOUT               127


#define MONITOR_MODE_SEL        128
#define SEL_MONITOR_MODE        128

#define MONITOR_DRAM_SEL        136
#define SEL_MONITOR_DRAM        136

#define PWM_SEL                 152
#define SEL_PWM                 152

#define USBPHY_CK_SEL           160
#define SEL_USBPHY              160

#define HDMI_TST_SEL            161
#define SEL_HDMI_TST            161

#define SF_SEL                  162
#define SEL_SFCS                162
#define SEL_SFCK                162
#define SEL_SFDI                162
#define SEL_SFDO                162

#define PTM_SEL                 163
#define SEL_PTM_CLK             163
#define SEL_PTM_CTL0            163
#define SEL_PTM_CTL1            163
#define SEL_PTM_CTL2            163
#define SEL_PTM_D               163


#define MDIO_MDC_SEL            164
#define SEL_SWITCH_MDIO         164
#define SEL_SWITCH_MDC          164

#define DCKINV_SEL              166
#define SEL_DCKINV              166

#define DA_APLLCK_SEL            168
#define SEL_DAAPLL               168

#define MCIN_MPMCLK_SEL          175
#define SEL_MCIN_MPMCLK          175

#define MCIN_MPBCK_SEL           178
#define SEL_MCIN_MPBCK           178

#define MCIN_MPLRCK_SEL          181
#define SEL_MCIN_MPLRCK          181

#define FEDIGITAL_0_SEL         224
#define SEL_FEDIGITAL_0         224

#define FEDIGITAL_1_SEL         225
#define SEL_FEDIGITAL_1         225

#define FEDIGITAL_3_SEL         227
#define SEL_FEDIGITAL_3         227

#define FEDIGITAL_4_SEL         228
#define SEL_FEDIGITAL_4         228

#define FEDIGITAL_5_SEL         229
#define SEL_FEDIGITAL_5         229

#define FEDIGITAL_6_SEL         230
#define SEL_FEDIGITAL_6         230

#define FEDIGITAL_7_SEL         231
#define SEL_FEDIGITAL_7         231

#define FEDIGITAL_9_SEL         233
#define SEL_FEDIGITAL_9         233

#define FEDIGITAL_10_SEL         234
#define SEL_FEDIGITAL_10         234

#define FEDIGITAL_11_SEL         235
#define SEL_FEDIGITAL_11         235

#define FEDIGITAL_14_SEL         238
#define SEL_FEDIGITAL_14         238

#define FEDIGITAL_15_SEL         239
#define SEL_FEDIGITAL_15         239


#define FEDIGITAL_17_SEL         241
#define SEL_FEDIGITAL_17         241

#define FEDIGITAL_18_SEL         242
#define SEL_FEDIGITAL_18         242

#define FEDIGITAL_20_SEL         244
#define SEL_FEDIGITAL_20         244

#define FEDIGITAL_21_SEL         245
#define SEL_FEDIGITAL_21         245

#define FEDIGITAL_22_SEL         246
#define SEL_FEDIGITAL_22         246

#define FEDIGITAL_23_SEL         247
#define SEL_FEDIGITAL_23         247

#define FEDIGITAL_24_SEL         248
#define SEL_FEDIGITAL_24         248

#define FEDIGITAL_25_SEL         249
#define SEL_FEDIGITAL_25         249

#define FEDIGITAL_26_SEL         250
#define SEL_FEDIGITAL_26         250

#define FEDIGITAL_27_SEL         251
#define SEL_FEDIGITAL_27         251

#define FEDIGITAL_28_SEL         252
#define SEL_FEDIGITAL_28         252

#define FEDIGITAL_29_SEL         253
#define SEL_FEDIGITAL_29         253

#define FEDIGITAL_30_SEL         254
#define SEL_FEDIGITAL_30         254

#define FEDIGITAL_31_SEL         255
#define SEL_FEDIGITAL_31         255


#define RS232_D3_SEL             260
#define SEL_UATXD3               260
#define SEL_UARXD3               260

#define VOUTHSYNC_SEL           288
#define SEL_VOUTHSYNC           288

#define VOUTVSYNC_SEL           290
#define SEL_VOUTVSYNC           290

#define VOUTD0_1_SEL            292
#define SEL_VOUTD0              292
#define SEL_VOUTD1              292


#define VOUTD10_11_SEL          294
#define SEL_VOUTD10             294
#define SEL_VOUTD11             294

#define VOUTD12_15_SEL          296
#define SEL_VOUTD12             296
#define SEL_VOUTD13             296
#define SEL_VOUTD14             296
#define SEL_VOUTD15             296

#define VOUTD2_7_SEL            298
#define SEL_VOUTD2              298
#define SEL_VOUTD3              298
#define SEL_VOUTD4              298
#define SEL_VOUTD5              298
#define SEL_VOUTD6              298
#define SEL_VOUTD7              298

#define VOUTD8_9_SEL            300
#define SEL_VOUTD8              300
#define SEL_VOUTD9              300

#define VOUTDE_SEL              302
#define SEL_VOUTDE              302

#define VOUTCLK_SEL             306
#define SEL_VOUTCLK             306

#define USB_GPIO_MODE_SEL_0       307
#define USB_GPIO_MODE_SEL_1       308
#define USB_GPIO_MODE_SEL_2       309



#define USB_I2C_1P_SEL             310
#define SEL_USB_SCL_1P             310
#define SEL_USB_SDA_1P             310

#define USB_I2C_2P_SEL             312
#define SEL_USB_SCL_2P             312
#define SEL_USB_SDA_2P             312

#define TMX_PWM_SEL                314

#define EXT_SF_SEL                 316
#define SEL_EXT_SDI                316
#define SEL_EXT_SDO                316

#define SPI_SEL                 318
#define SEL_SPI_SDATA           318
#define SEL_SPI_CLE             318
#define SEL_SPI_CLK             318
#define SEL_SPI_CEB             318


#define EXT_TS0_SEL             320
#define SEL_EXT_TS0_DATA0       320
#define SEL_EXT_TS0_SYNC        320
#define SEL_EXT_TS0_VALID       320
#define SEL_EXT_TS0_CLK         320

#define EXT_TS1_SEL             322
#define SEL_EXT_TS1_DATA0       322
#define SEL_EXT_TS1_SYNC        322
#define SEL_EXT_TS1_VALID       322
#define SEL_EXT_TS1_CLK         322

#define TSOUT_SEL               324
#define SEL_TSOUT_DATA0         324
#define SEL_TSOUT_SYNC          324
#define SEL_TSOUT_VALID         324
#define SEL_TSOUT_CLK           324

#define TSOUT_PARA_SEL          325
#define SEL_TSOUT_DATA1         325

#define VINCLK_SEL              326
#define SEL_VINCLK              326

#define VINHSYNC_SEL            328
#define SEL_VINHSYNC            328

#define VINVSYNC_SEL            330
#define SEL_VINVSYNC            330

#define VIND0_1_SEL             332
#define SEL_VIND0               332
#define SEL_VIND1               332

#define VIND2_7_SEL             333
#define SEL_VIND2               333
#define SEL_VIND3               333
#define SEL_VIND4               333
#define SEL_VIND5               333
#define SEL_VIND6               333
#define SEL_VIND7               333

#define VIND8_9_SEL             334
#define SEL_VIND8               334
#define SEL_VIND9               334

#define VIND10_11_SEL            335
#define SEL_VIND10               335
#define SEL_VIND11               335

#define VIND12_15_SEL            336
#define SEL_VIND12               336
#define SEL_VIND15               336

#define EXT_TS0_PARA_SEL        337
#define SEL_EXT_TS0_DATA1       337
#define SEL_EXT_TS0_DATA2       337
#define SEL_EXT_TS0_DATA3       337
#define SEL_EXT_TS0_DATA4       337
#define SEL_EXT_TS0_DATA5       337
#define SEL_EXT_TS0_DATA6       337
#define SEL_EXT_TS0_DATA7       337

#define AUD_AMUTE_PDWNC_SEL     340
#define SEL_AUD_AMUTE_PDWNC     340

#define SPDIF_IN_OPTICAL_SEL    352
#define SEL_SPDIF_IN_OPTICAL    352

#define AUD2_SEL                356
#define SEL_AO2MCLK             356
#define SEL_AO2BCK              356
#define SEL_AO2LRCK             356
#define SEL_AO2SDATA0           356
#define SEL_AO2SDATA1           356
#define SEL_AO2SDATA2           356

#define RS232_D2_SEL            359
#define SEL_UATXD1              359
#define SEL_UARXD1              359

#define HDMI_RX_I2C_SEL         364
#define SEL_HDMI_RX_I2C_SCL     364
#define SEL_HDMI_RX_I2C_SDA     364

#define JTAG_4PIN_SEL           369
#define SEL_JTAG_TRST           369

#define AUD2_DATA3_SEL          372
#define SEL_AO2SDATA3           372

#define AUD2_SPDIF2_SEL         374
#define SEL_SPDIF2              374

#define JTAG_PDWNC_HDMI_SEL     381
#define SEL_JTAGE_PULL_DOWN     381

#define VOUT_PWDN_CLK_SEL       384
#define VOUT_PWDN_SYNC_SEL      385
#define VOUT_PWDN_DO_D2_SEL     386
#define VOUT_PWDN_D3_SEL        387
#define VOUT_PWDN_D4_D5_SEL     388
#define VOUT_PWDN_D6_D7_SEL     389
#define VOUT_PWDN_D8_D15_SEL    390
#define VOUT_VIN_CLK_SEL        391
#define VOUT_VIN_SYNC_SEL       392
#define VOUT_VIN_D1_D3_SEL      393
#define VOUT_VIN_D4_D7_SEL      394
#define VOUT_VIN_D8_D9_SEL      395
#define VOUT_VIN_D10_D11_SEL    396
#define VOUT_VIN_D12_D15_SEL    397
#define VOUT_VIN_D16_D19_SEL    398
#define VOUT_VIN_D20_D21_SEL    399
#define VOUT_VIN_D22_D23_SEL    400
#define VOUT_VIN_D24_SEL        401
#define VOUT_VIN_D25_D29_SEL    402
#define VOUT_VIN_D31_SEL        403
#define VOUT_GPIO0_SEL          404
#define VOUT_GPIO1_SEL          405
#define VOUT_GPIO2_SEL          406
#define VOUT_GPIO3_SEL          407
#define VOUT_VIN_D0_SEL         408
#define ESIF_DOVE_SEL           412
#define DGO_PAD_MUL_SEL         414
#define DGI_PAD_MUL_SEL         415

#define PD_RS232_SEL            443

#if 1
//PAD_FECTL @ 0X280~0X284
#define SEL_FECTL_0             448
#define SEL_FECTL_1             449
#define SEL_FECTL_2             450
#define SEL_FECTL_3             451
#define SEL_FECTL_4             452
#define SEL_FECTL_5             453
#define SEL_FECTL_6             454
#define SEL_FECTL_7             455
#define SEL_FECTL_8             456
#define SEL_FECTL_9             457
#define SEL_FECTL_10             458
#define SEL_FECTL_11             459
#define SEL_FECTL_12             460
#define SEL_FECTL_13             461
#define SEL_FECTL_14             462
#define SEL_FECTL_15             463
#define SEL_FECTL_16             464
#define SEL_FECTL_17             465
#define SEL_FECTL_18             466
#define SEL_FECTL_19             467
#define SEL_FECTL_20             468
#define SEL_FECTL_21             469
#define SEL_FECTL_22             470
#define SEL_FECTL_23             471
#define SEL_FECTL_24             472
#define SEL_FECTL_25             473
#define SEL_FECTL_26             474
#define SEL_FECTL_27             475
#define SEL_FECTL_28             476
#define SEL_FECTL_29             477
#define SEL_FECTL_30             478
#define SEL_FECTL_31             479
#define SEL_FECTL_32             480
#define SEL_FECTL_33             481
#define SEL_FECTL_34             482
#endif
//PAD_PWMCTL @ 0X28C
#define ETLED_0_SEL             560
#define SEL_ETLED_0             560

#define ETLED_1_SEL             564
#define SEL_ETLED_1             564

#define ETLED_2_SEL             568 
#define SEL_ETLED_2             568

#define ETLED_3_SEL             572 
#define SEL_ETLED_3             572



#define MAX_PINMUX_SEL           576


#endif /* __MT8580_GPIO_PINMUX_H */

