/*
 *  linux/include/asm-arm/arch-mt85xx/irqs.h
 *
 *  Copyright (C) 2009 MediaTek Inc.
 */
#ifndef __IRQS_VECTOR_8580_
#define __IRQS_VECTOR_8580_

#define IRQ_MT85XX_GIC_START			32

//----------------------------------------------------------------------------
// IRQ Vectors
  //#define   VECTOR_(Reserved)           (IRQ_MT85XX_GIC_START + 0)
  #define   VECTOR_TTD_VSYNC            (IRQ_MT85XX_GIC_START + 1)
  #define   VECTOR_GFX3D_2              (IRQ_MT85XX_GIC_START + 2)
  #define   VECTOR_EXT                  (IRQ_MT85XX_GIC_START + 3)
  #define   VECTOR_MSDC0                (IRQ_MT85XX_GIC_START + 4)
  #define   VECTOR_EXT2                 (IRQ_MT85XX_GIC_START + 5)
  #define   VECTOR_VDOIN                (IRQ_MT85XX_GIC_START + 6)   //VECTOR_DEMUX in 8550
  #define   VECTOR_GRAPH                (IRQ_MT85XX_GIC_START + 7)
  #define   VECTOR_JPGDEC               (IRQ_MT85XX_GIC_START + 8)
  #define   VECTOR_FONT                 (IRQ_MT85XX_GIC_START + 9)
  #define   VECTOR_IOMMU                (IRQ_MT85XX_GIC_START + 10)
  #define   VECTOR_GFX3D_0              (IRQ_MT85XX_GIC_START + 11)
  #define   VECTOR_SMC                  (IRQ_MT85XX_GIC_START + 12)
  #define   VECTOR_RLE                  (IRQ_MT85XX_GIC_START + 13)
  #define   VECTOR_RS232_1              (IRQ_MT85XX_GIC_START + 14)
  #define   VECTOR_DSP                  (IRQ_MT85XX_GIC_START + 15)
  #define   VECTOR_SPD                  (IRQ_MT85XX_GIC_START + 16)
  #define   VECTOR_DISP_VSYNC           (IRQ_MT85XX_GIC_START + 17)
  #define   VECTOR_SVO_IFINT            (IRQ_MT85XX_GIC_START + 18)
  #define   VECTOR_SVOIF                (IRQ_MT85XX_GIC_START + 18)
  #define   VECTOR_VDOUT2               (IRQ_MT85XX_GIC_START + 19)
  #define   VECTOR_DDMAI                (IRQ_MT85XX_GIC_START + 20)
  #define   VECTOR_PL310                (IRQ_MT85XX_GIC_START + 21)
  #define   VECTOR_USB                  (IRQ_MT85XX_GIC_START + 22)
  #define   VECTOR_GFX3D_1              (IRQ_MT85XX_GIC_START + 23)
  #define   VECTOR_AUDASRC              (IRQ_MT85XX_GIC_START + 24)
  #define   VECTOR_T2                   (IRQ_MT85XX_GIC_START + 25)
  #define   VECTOR_T1                   (IRQ_MT85XX_GIC_START + 26)
  #define   VECTOR_T0                   (IRQ_MT85XX_GIC_START + 27)
  #define   VECTOR_DSPC                 (IRQ_MT85XX_GIC_START + 28)
  #define   VECTOR_SVO_FE1INT           (IRQ_MT85XX_GIC_START + 29)
  #define   VECTOR_SVO_FE0INT           (IRQ_MT85XX_GIC_START + 30)
  #define   VECTOR_VSYNC                (IRQ_MT85XX_GIC_START + 31)
  //===============================================
  #define   VECTOR_GCPU                 (IRQ_MT85XX_GIC_START + 32)
  #define   VECTOR_NFI                  (IRQ_MT85XX_GIC_START + 33)
  #define   VECTOR_PWMIP_2              (IRQ_MT85XX_GIC_START + 34)
  #define   VECTOR_PWMIP_1              (IRQ_MT85XX_GIC_START + 35)
  #define   VECTOR_SPDIF                (IRQ_MT85XX_GIC_START + 36)
  #define   VECTOR_NR                   (IRQ_MT85XX_GIC_START + 37)
  #define   VECTOR_EXT4                 (IRQ_MT85XX_GIC_START + 38)
  #define   VECTOR_AVLINK               (IRQ_MT85XX_GIC_START + 39)
  #define   VECTOR_DRAMC                (IRQ_MT85XX_GIC_START + 40)
  #define   VECTOR_RESIZER2             (IRQ_MT85XX_GIC_START + 41)
  #define   VECTOR_RESIZER1             (IRQ_MT85XX_GIC_START + 42)
  #define   VECTOR_RESIZER0             (IRQ_MT85XX_GIC_START + 43)
  #define   VECTOR_HDMI                 (IRQ_MT85XX_GIC_START + 44)
  #define   VECTOR_DISP2_VSYNC          (IRQ_MT85XX_GIC_START + 45)
  #define   VECTOR_HDMI_TX              (IRQ_MT85XX_GIC_START + 46)
  #define   VECTOR_SPIINT               (IRQ_MT85XX_GIC_START + 47)
  #define   VECTOR_DDIINT               (IRQ_MT85XX_GIC_START + 48)
  #define   VECTOR_VDOUTAUX0            (IRQ_MT85XX_GIC_START + 49)
  #define   VECTOR_DMXINT               (IRQ_MT85XX_GIC_START + 50)
  #define   VECTOR_VENC                 (IRQ_MT85XX_GIC_START + 51)
  #define   VECTOR_PWDNC                (IRQ_MT85XX_GIC_START + 52)
  #define   VECTOR_ATA1                 (IRQ_MT85XX_GIC_START + 53)   //There is only one ATA in 8555
  #define   VECTOR_GFX3DINT4            (IRQ_MT85XX_GIC_START + 54)
  #define   VECTOR_GFX3DINT3            (IRQ_MT85XX_GIC_START + 55)
  #define   VECTOR_SPU                  (IRQ_MT85XX_GIC_START + 56)
  #define   VECTOR_PVR                  (IRQ_MT85XX_GIC_START + 57)   //VECTOR_PVR=VECTOR_DEMUX
  #define   VECTOR_TSMUX                (IRQ_MT85XX_GIC_START + 58)
  #define   VECTOR_FMC                  (IRQ_MT85XX_GIC_START + 59)
  #define   VECTOR_MSDC1                (IRQ_MT85XX_GIC_START + 60)
  #define   VECTOR_DHMIRXSCD            (IRQ_MT85XX_GIC_START + 61)
  #define   VECTOR_HDMIRXINT            (IRQ_MT85XX_GIC_START + 62)
  //#define   VECTOR_(Reserved)           (IRQ_MT85XX_GIC_START + 63)
  //===============================================
  #define   VECTOR_PERI                 (IRQ_MT85XX_GIC_START + 64)
  #define   VECTOR_RS232_3              (IRQ_MT85XX_GIC_START + 65)
  #define   VECTOR_PARSER1              (IRQ_MT85XX_GIC_START + 66)
  #define   VECTOR_PARSER               (IRQ_MT85XX_GIC_START + 67)
  #define   VECTOR_DISP_END2            (IRQ_MT85XX_GIC_START + 68)
  #define   VECTOR_DRAMC1               (IRQ_MT85XX_GIC_START + 69)
  #define   VECTOR_RS232_2              (IRQ_MT85XX_GIC_START + 70)
  #define   VECTOR_PNG2                 (IRQ_MT85XX_GIC_START + 71)
  #define   VECTOR_PNG1                 (IRQ_MT85XX_GIC_START + 72)
  #define   VECTOR_GIF2                 (IRQ_MT85XX_GIC_START + 73)
  #define   VECTOR_GIF1                 (IRQ_MT85XX_GIC_START + 74)
  #define   VECTOR_PSTQ                 (IRQ_MT85XX_GIC_START + 75)
  #define   VECTOR_SRCQ                 (IRQ_MT85XX_GIC_START + 76)
  #define   VECTOR_OSD5_UNFLW           (IRQ_MT85XX_GIC_START + 77)
  #define   VECTOR_OSD4_UNFLW           (IRQ_MT85XX_GIC_START + 78)
  #define   VECTOR_OSD3_UNFLW           (IRQ_MT85XX_GIC_START + 79)
  #define   VECTOR_OSD2_UNFLW           (IRQ_MT85XX_GIC_START + 80)
  #define   VECTOR_OSD1_UNFLW           (IRQ_MT85XX_GIC_START + 81)
  #define   VECTOR_USB3                 (IRQ_MT85XX_GIC_START + 82)
  #define   VECTOR_DISP_END             (IRQ_MT85XX_GIC_START + 83)
  #define   VECTOR_TCPIP                (IRQ_MT85XX_GIC_START + 84)
  #define   VECTOR_USB2                 (IRQ_MT85XX_GIC_START + 85)
  #define   VECTOR_EPHY                 (IRQ_MT85XX_GIC_START + 86)
  #define   VECTOR_SACD                 (IRQ_MT85XX_GIC_START + 87)
  #define   VECTOR_DISPVDO2_UNDERRUN    (IRQ_MT85XX_GIC_START + 88)
  #define   VECTOR_ENET                 (IRQ_MT85XX_GIC_START + 89)
  #define   VECTOR_VDLIT                (IRQ_MT85XX_GIC_START + 90)
  #define   VECTOR_VDFUL                (IRQ_MT85XX_GIC_START + 91)
  #define   VECTOR_DSPB2RISC            (IRQ_MT85XX_GIC_START + 92)
  #define   VECTOR_DISPVDO_UNDERRUN     (IRQ_MT85XX_GIC_START + 93)
  #define   VECTOR_PNG                  (IRQ_MT85XX_GIC_START + 94)
  #define   VECTOR_GIF                  (IRQ_MT85XX_GIC_START + 95)

  // ToDo
  #define   VECTOR_INT_P_GPIO0          0
  #define   VECTOR_INT_P_GPIO1          1
  #define   VECTOR_INT_P_GPIO2          2
  #define   VECTOR_INT_P_GPIO3          3
  #define   VECTOR_INT_P_GPIO4          4
  #define   VECTOR_INT_P_GPIO5          5
  #define   VECTOR_INT_P_GPIO6          6
  #define   VECTOR_INT_P_GPIO7          7
  //#define   VECTOR_INT_P_xx            8
  #define   VECTOR_INT_P_DBG_UART       9
  #define   VECTOR_INT_P_SIFS           10
  #define   VECTOR_INT_P_CEC            11
  #define   VECTOR_INT_P_ETNET          12
  #define   VECTOR_INT_P_IR             13
  #define   VECTOR_INT_P_SIFM           14
  #define   VECTOR_INT_P_DDCCI          15
  #define   VECTOR_INT_P_SFFE           16
  //#define   VECTOR_INT_P_DDCCIS         17
  
#endif /*#ifndef __IRQS_VECTOR_8580_*/

