/*
 * arch/arm/mach-mt85xx/include/mach/mt85xx_pinmux_table.h
 *
 * Copyright (C) 2010 MediaTek Inc
 *
 *
 */
#ifndef __MT85XX_PINMUX_TABLE_H
#define __MT85XX_PINMUX_TABLE_H

#define PINMUX_FUNCTION0        0
#define PINMUX_FUNCTION1        1
#define PINMUX_FUNCTION2        2
#define PINMUX_FUNCTION3        3
#define PINMUX_FUNCTION4        4
#define PINMUX_FUNCTION5        5
#define PINMUX_FUNCTION6        6
#define PINMUX_FUNCTION7        7
#define PINMUX_FUNCTION8        8
#define PINMUX_FUNCTION9        9
#define PINMUX_FUNCTION10       10
#define PINMUX_FUNCTION11       11
#define PINMUX_FUNCTION12       12
#define PINMUX_FUNCTION13       13
#define PINMUX_FUNCTION14       14
#define PINMUX_FUNCTION15       15
#define PINMUX_FUNCTION16       16
#define PINMUX_FUNCTION17       17
#define PINMUX_FUNCTION18       18
#define PINMUX_FUNCTION19       19
#define PINMUX_FUNCTION20       20

#if (CONFIG_CHIP_VER_CURR == CONFIG_CHIP_VER_MT8561)
#define MAX_PINMUX_FUNCTION     20
#else
#define MAX_PINMUX_FUNCTION     15
#endif

#ifdef __KERNEL_GPIO_PINMUX__

#include <mach/inc/x_typedef.h>
#include <config/arch/chip_ver.h>

  #if (CONFIG_CHIP_VER_CURR == CONFIG_CHIP_VER_MT8530)
#include <mach/mt8530_gpio_pinmux.h>
#include "mt8530_pinmux_table.h"
  #elif (CONFIG_CHIP_VER_CURR == CONFIG_CHIP_VER_MT8550)
    #if CONFIG_CHIP_VER_HMP    
#include <mach/mt8652_gpio_pinmux.h>
#include "mt8652_pinmux_table.h"
    #else  
#include <mach/mt8550_gpio_pinmux.h>
#include "mt8550_pinmux_table.h"
    #endif
  #elif (CONFIG_CHIP_VER_CURR == CONFIG_CHIP_VER_MT8555)
#include <mach/mt8555_gpio_pinmux.h>
#include "mt8555_pinmux_table.h"
  #elif (CONFIG_CHIP_VER_CURR == CONFIG_CHIP_VER_MT8560)
#include <mach/mt8560_gpio_pinmux.h>
#include "mt8560_pinmux_table.h"
  #elif (CONFIG_CHIP_VER_CURR == CONFIG_CHIP_VER_MT8561)
#include <mach/mt8561_gpio_pinmux.h>
#include "mt8561_pinmux_table.h"
  #elif (CONFIG_CHIP_VER_CURR == CONFIG_CHIP_VER_MT8580)
#include <mach/mt8580_gpio_pinmux.h>
#include "mt8580_pinmux_table.h"
  #endif
#endif  /* __KERNEL_GPIO_PINMUX__ */

#ifdef __FASTLOGO_GPIO_PINMUX__

#include "x_typedef.h"
#include "chip_ver.h"

  #if (CONFIG_CHIP_VER_CURR == CONFIG_CHIP_VER_MT8530)
#include "mt8530_gpio_pinmux.h"
#include "mt8530_pinmux_table.h"
  #elif (CONFIG_CHIP_VER_CURR == CONFIG_CHIP_VER_MT8550)
    #if CONFIG_CHIP_VER_HMP    
#include "mt8652_gpio_pinmux.h"
#include "mt8652_pinmux_table.h"
    #else    
#include "mt8550_gpio_pinmux.h"
#include "mt8550_pinmux_table.h"
    #endif
  #elif (CONFIG_CHIP_VER_CURR == CONFIG_CHIP_VER_MT8555)
#include "mt8555_gpio_pinmux.h"
#include "mt8555_pinmux_table.h"
  #elif (CONFIG_CHIP_VER_CURR == CONFIG_CHIP_VER_MT8560)
#include "mt8560_gpio_pinmux.h"
#include "mt8560_pinmux_table.h"
  #elif (CONFIG_CHIP_VER_CURR == CONFIG_CHIP_VER_MT8561)
#include "mt8561_gpio_pinmux.h"
#include "mt8561_pinmux_table.h"
  #elif (CONFIG_CHIP_VER_CURR == CONFIG_CHIP_VER_MT8580)
#include "mt8580_gpio_pinmux.h"
#include "mt8580_pinmux_table.h"
  #endif
#endif  /* __FASTLOGO_GPIO_PINMUX__ */


#ifdef __UBOOT_GPIO_PINMUX__

#include <asm/arch/x_typedef.h>
#include <chip_ver.h>

  #if (CONFIG_CHIP_VER_CURR == CONFIG_CHIP_VER_MT8530)
#include <asm/arch/mt8530_gpio_pinmux.h>
#include <asm/arch/mt8530_pinmux_table.h>
  #elif (CONFIG_CHIP_VER_CURR == CONFIG_CHIP_VER_MT8550)
    #if CONFIG_CHIP_VER_HMP    
#include <asm/arch/mt8652_gpio_pinmux.h>
#include <asm/arch/mt8652_pinmux_table.h>
    #else      
#include <asm/arch/mt8550_gpio_pinmux.h>
#include <asm/arch/mt8550_pinmux_table.h>
    #endif
  #elif (CONFIG_CHIP_VER_CURR == CONFIG_CHIP_VER_MT8555)
#include <asm/arch/mt8555_gpio_pinmux.h>
#include <asm/arch/mt8555_pinmux_table.h>
  #elif (CONFIG_CHIP_VER_CURR == CONFIG_CHIP_VER_MT8560)
#include <asm/arch/mt8560_gpio_pinmux.h>
#include <asm/arch/mt8560_pinmux_table.h>
  #elif (CONFIG_CHIP_VER_CURR == CONFIG_CHIP_VER_MT8561)
#include <asm/arch/mt8561_gpio_pinmux.h>
#include <asm/arch/mt8561_pinmux_table.h>
  #elif (CONFIG_CHIP_VER_CURR == CONFIG_CHIP_VER_MT8580)
#include <asm/arch/mt8580_gpio_pinmux.h>
#include <asm/arch/mt8580_pinmux_table.h>
  #endif
#endif /* __UBOOT_GPIO_PINMUX__ */

#endif /* __MT85XX_PINMUX_TABLE_H */

