/*
 * arch/arm/mach-mt85xx/include/mach/mt8652_gpio_pinmux.h
 *
 * Copyright (C) 2010 MediaTek Inc
 *
 * 
 *
 */

#ifndef __MT8652_GPIO_PINMUX_H
#define __MT8652_GPIO_PINMUX_H

// GPIO name definitions
#define PIN_GPIO0           0
#define PIN_GPIO1           1
#define PIN_GPIO2           2
#define PIN_GPIO3           3
#define PIN_GPIO4           4
#define PIN_GPIO5           5
#define PIN_GPIO6           6
#define PIN_GPIO7           7
#define PIN_AMUTE           8
#define PIN_AOBCK           9
#define PIN_AOLRCK          10
#define PIN_AOMCLK          11
#define PIN_AOSDATA0        12
#define PIN_AOSDATA1        13
#define PIN_AOSDATA2        14
#define PIN_AOSDATA3        15
#define PIN_AOSDATA4        16
#define PIN_AOSDATA5        17
#define PIN_MCIN            53   
#define PIN_NFALE           54
#define PIN_NFCEN           55
#define PIN_NFCEN2          56
#define PIN_NFCLE           57
#define PIN_NFD0            58
#define PIN_NFD1            59      
#define PIN_NFD2            60
#define PIN_NFD3            61      
#define PIN_NFD4            62
#define PIN_NFD5            63     

#define PIN_NFD6            64
#define PIN_NFD7            65      
#define PIN_NFRBN           66
#define PIN_NFRBN2          67
#define PIN_NFREN           68
#define PIN_NFWEN           69
#define PIN_SCL             70
#define PIN_SDA             71
#define PIN_SFCK            72
#define PIN_SFCS            73
#define PIN_SFDI            74
#define PIN_SFDO            75
#define PIN_SPBCK           76
#define PIN_SPDATA          77
#define PIN_SPDIF           78
#define PIN_SPLRCK          79
#define PIN_SPMCLK          80
#define PIN_VOUTCLK1        81
#define PIN_VOUTD0          82
#define PIN_VOUTD1          83
#define PIN_VOUTD10         84
#define PIN_VOUTD11         85
#define PIN_VOUTD12         86
#define PIN_VOUTD13         87
#define PIN_VOUTD14         88
#define PIN_VOUTD15         89
#define PIN_VOUTD2          90
#define PIN_VOUTD3          91
#define PIN_VOUTD4          92
#define PIN_VOUTD5          93
#define PIN_VOUTD6          94
#define PIN_VOUTD7          95
                        
#define PIN_VOUTD8          96
#define PIN_VOUTD9          97
#define PIN_VOUTHSYNC       98
#define PIN_VOUTVSYNC       99
#define PIN_TDO             100
#define PIN_TRST            101
#define PIN_TMS             102
#define PIN_TDI             103
#define PIN_TCK             104

#define PIN_VFD_STB         105
#define PIN_VFD_CLK         106 
#define PIN_VFD_DATA        107
#define PIN_LCDRD           108
//                                             109
#define PIN_ETMDIO          110
#define PIN_ETMDC           111
#define PIN_ETRXER          112
#define PIN_ETTXER          113
#define PIN_ETRXDV          114
#define PIN_ETTXEN          115 
#define PIN_ETCRS           116 
#define PIN_ETCOL           117
#define PIN_ETRXD3          118
#define PIN_ETRXD2          119
#define PIN_ETRXD1          120
#define PIN_ETRXD0          121
#define PIN_ETTXD3          122
#define PIN_ETTXD2          123
#define PIN_ETTXD1          124  
#define PIN_ETTXD0          125
#define PIN_ETRXCLK         126 
#define PIN_ETTXCLK         127
#define PIN_HDMI_SCK        128
#define PIN_HDMI_SD         129 
#define PIN_HDMI_HTPLG      130
#define PIN_HDMI_CEC        131 
#define PIN_UATXD           132
#define PIN_UARXD           133 
#define PIN_IR              134 
#define PIN_GPIO8           135 
   
#define PIN_UNKNOWN         255

// Total GPIO is 135.
#define TOTAL_GPIO_NUM      135

//8652 Pin mux function definitions
#define AUD_MCLK_SEL            0
#define SEL_AOMCLK              0
#define SEL_AOBCK               0
#define SEL_AOLRCK              0

#define LIN_SPDATA_SEL          2
#define SEL_LINE_SPDATA         2

#define AUD_SDATA0_SEL          6
#define SEL_AOSDATA0            6

#define AUD_SDATA1_SEL          7
#define SEL_AOSDATA1            7

#define AUD_SDATA2_SEL          8
#define SEL_AOSDATA2            8

#define AUD_SDATA3_SEL          9
#define SEL_AOSDATA3            9

#define AUD_SDATA4_SEL          10
#define SEL_AOSDATA4            10

#define AUD_SDATA5_SEL          11
#define SEL_AOSDATA5            11

#define AUD_MUTE_SEL            12
#define SEL_AMUTE               12

#define AUD_MCIN_SEL            13 
#define SEL_MCIN                13

#define AUD_SPDIF_SEL           14 
#define SEL_SPDIF               14

#define AUD_SPDATA_SEL          15 
#define SEL_SPDATA0             15

#define AUD_SPLRCK_SEL          18
#define SEL_SPLRCK              18

#define AUD_SPBCK_SEL           19
#define SEL_SPBCK               19

#define AUD_SPMCLK_SEL          20
#define SEL_SPMCLK              20

#define I2C_SEL                 22
#define SEL_SCL                 22 
#define SEL_SDA                 22

#define EXT_INTR4_SEL           23
#define SEL_EXT_INTR4           23

#define SEL_JTDO                27
#define SEL_JTCLK               27
#define SEL_JTMS                27
#define SEL_JTDI                27
#define SEL_JTRST_B             27
#define SEL_JRTCLK              27

#define SEL_LVDS1P              29
#define SEL_LVDS1N              29
#define SEL_LVDS2P              29
#define SEL_LVDS2N              29
#define SEL_LVDS3P              29
#define SEL_LVDS3N              29
#define SEL_LVDS4P              29
#define SEL_LVDS4N              29
#define SEL_LVDS5P              29
#define SEL_LVDS5N              29

#define NAND_SEL                30
#define SEL_NFREN               30
#define SEL_NFCLE               30 
#define SEL_NFCEN               30 
#define SEL_NFWEN               30
#define SEL_NFALE               30
#define SEL_NFRBN               30
#define SEL_NFD0                30
#define SEL_NFD1                30
#define SEL_NFD2                30
#define SEL_NFD3                30
#define SEL_NFD4                30
#define SEL_NFD5                30
#define SEL_NFD6                30
#define SEL_NFD7                30

#define NAND_RDY2_SEL           31
#define SEL_NFRBN2              31 

#define VOUTHSYNC_SEL           34
#define SEL_VOUTHSYNC           34 

#define VOUTVSYNC_SEL           35
#define SEL_VOUTVSYNC           35

#define VOUTD2_7_SEL            36
#define SEL_VOUTD2              36
#define SEL_VOUTD3              36
#define SEL_VOUTD4              36
#define SEL_VOUTD5              36
#define SEL_VOUTD6              36
#define SEL_VOUTD7              36

#define VOUTD8_9_SEL            37 
#define SEL_VOUTD8              37
#define SEL_VOUTD9              37

#define VOUTD12_17_SEL          38
#define SEL_VOUTD12             38
#define SEL_VOUTD13             38
#define SEL_VOUTD14             38
#define SEL_VOUTD15             38
#define SEL_VOUTD16             38
#define SEL_VOUTD17             38

#define RS232_D2_SEL            40 
#define SEL_UATXD2              40
#define SEL_UARXD2              40

#define AUD2_SEL                42
#define SEL_AO2MCLK             42 
#define SEL_AO2BCK              42
#define SEL_AO2LRCK             42
#define SEL_AO2SDATA0           42
#define SEL_AO2SDATA1           42
#define SEL_AO2SDATA2           42
#define SEL_AO2SDATA3           42
#define SEL_SPDIF2              42

#define AUD2_SACD_SEL           43
#define SEL_AO2SDATA4           43
#define SEL_AO2SDATA5           43 

#define M27_OUT_SEL             52
#define SEL_MJC                 52

#define SF_CS2_SEL              56  
#define SEL_SFCS2               56

#define PD_RS232_SEL            60 
#define SEL_UATXD1              60
#define SEL_UARXD1              60

#define NAND_CEN2_SEL           64
#define SEL_NFCEN2              64 

#define NAND_CEN3_SEL           68
#define SEL_NFCEN3              68 

#define NAND_CEN4_SEL           72
#define SEL_NFCEN4              72 

#define EXT_INTR1_SEL           76
#define SEL_EXT_INTR1           76

#define EXT_INTR2_SEL           80
#define SEL_EXT_INTR2           80

#define RS232_D3_SEL            84
#define SEL_UATXD3              84
#define SEL_UARXD3              84

#define HDMI_MSCK_EN_SEL        87
#define SEL_HDMI_MSCK_EN        87

#define SI2C_SEL                88 
#define SEL_SCLS                88 
#define SEL_SDAS                88

#define HDMI_I2C_SEL            92 
#define SEL_MSD                 92
#define SEL_MSCK                92 

#define VOUTDE_SEL              96
#define SEL_VOUTDE              96

#define TEST_IN_SEL             99 
#define SEL_TIND31              99
#define SEL_TIND30              99 
#define SEL_TIND29              99
#define SEL_TIND28              99
#define SEL_TIND27              99
#define SEL_TIND26              99
#define SEL_TIND25              99
#define SEL_TIND24              99
#define SEL_TIND23              99
#define SEL_TIND22              99
#define SEL_TIND21              99
#define SEL_TIND20              99
#define SEL_TIND19              99
#define SEL_TIND18              99
#define SEL_TIND17              99
#define SEL_TIND16              99
#define SEL_TIND15              99
#define SEL_TIND14              99
#define SEL_TIND13              99
#define SEL_TIND12              99
#define SEL_TIND11              99
#define SEL_TIND10              99
#define SEL_TIND9               99
#define SEL_TIND8               99
#define SEL_TIND7               99
#define SEL_TIND6               99
#define SEL_TIND5               99
#define SEL_TIND4               99
#define SEL_TIND3               99
#define SEL_TIND2               99
#define SEL_TIND1               99
#define SEL_TIND0               99

#define MONITOR_SEL             100 
#define SEL_MOUTB31             100
#define SEL_MOUTB30             100
#define SEL_MOUTB29             100
#define SEL_MOUTB28             100
#define SEL_MOUTB27             100
#define SEL_MOUTB26             100
#define SEL_MOUTB25             100
#define SEL_MOUTB24             100
#define SEL_MOUTB23             100
#define SEL_MOUTB22             100
#define SEL_MOUTB21             100
#define SEL_MOUTB20             100
#define SEL_MOUTB19             100
#define SEL_MOUTB18             100
#define SEL_MOUTB17             100
#define SEL_MOUTB16             100
#define SEL_MOUTB15             100
#define SEL_MOUTB14             100
#define SEL_MOUTB13             100
#define SEL_MOUTB12             100
#define SEL_MOUTB11             100
#define SEL_MOUTB10             100
#define SEL_MOUTB9              100
#define SEL_MOUTB8              100
#define SEL_MOUTB7              100
#define SEL_MOUTB6              100
#define SEL_MOUTB5              100
#define SEL_MOUTB4              100
#define SEL_MOUTB3              100
#define SEL_MOUTB2              100
#define SEL_MOUTB1              100
#define SEL_MOUTB0              100

#define VOUTD0_1_SEL            102 
#define SEL_VOUTD0              102
#define SEL_VOUTD1              102

#define VOUTD10_11_SEL          103  
#define SEL_VOUTD10             103 
#define SEL_VOUTD11             103 

#define AOMCLK_PWM_SEL          104      
#define SEL_AOMCLK_PWM          104

#define AOBCK_PWM_SEL           105  
#define SEL_AOBCK_PWM           105

#define AOLRCK_PWM_SEL          106  
#define SEL_AOLRCK_PWM          106

#define AOSDATA0_PWM_SEL        107 
#define SEL_AOSDATA0_PWM        107

#define AOSDATA1_PWM_SEL        108 
#define SEL_AOSDATA1_PWM        108

#define AOSDATA2_PWM_SEL        109 
#define SEL_AOSDATA2_PWM        109

#define AOSDATA3_PWM_SEL        110 
#define SEL_AOSDATA3_PWM        110

#define AOSDATA4_PWM_SEL        111 
#define SEL_AOSDATA4_PWM        111

#define AOSDATA5_PWM_SEL        112 
#define SEL_AOSDATA5_PWM        112

#define SPDATA_PWM_SEL          113 
#define SEL_SPDATA_PWM          113

#define HDMI_EXT_DATA_SEL       114 
#define SEL_HDMI_EXT_DATA       114

#define HDMI_EXT_DSD_SEL        115 
#define SEL_HDMI_EXT_DSD        115

#define HDMI_EXT_SPDF_SEL       116 
#define SEL_HDMI_EXT_SPDF       116

#define HDMI_EXT_ACK_SEL        117 
#define SEL_HDMI_EXT_ACK        117

#define HDMI_EXT_BCK_SEL        118 
#define SEL_HDMI_EXT_BCK        118

#define HDMI_EXT_LRCK_SEL       119 
#define SEL_HDMI_EXT_LRCK       119

#define HDMI_RX_SDATA0_SEL      120 
#define SEL_HDMI_RX_SDATA0      120

#define HDMI_RX_SPDF_SEL        121 
#define SEL_HDMI_RX_SPDF        121

#define EFVDDQ_SEL              124
#define SEL_EFVDDQ              124

#define EFSRC_SEL               125 
#define SEL_EFSRC               125

#define MONITOR_MODE_SEL        128
#define SEL_MONITOR_MODE        128

#define MONITOR_DRAM_SEL        136        
#define SEL_MONITOR_DRAM        136

#define VDOUT0_5_SEL            144 
#define SEL_VOUTVSYNC_FIFO      144
#define SEL_VOUTHSYNC_FIFO      145
#define SEL_VOUTD0_1            146
#define SEL_VOUTD2_7            147
#define SEL_VOUTD8_9            148
#define SEL_VOUTD10_11          149

#define NAND_16BIT_SEL          150  
#define SEL_NFD8                150 
#define SEL_NFD9                150 
#define SEL_NFD10               150 
#define SEL_NFD11               150 
#define SEL_NFD12               150 
#define SEL_NFD13               150 
#define SEL_NFD14               150 
#define SEL_NFD15               150 

#define PWM_SEL                 152
#define SEL_PWM                 152

#define VDOUT6_8_SEL            157 
#define SEL_VDOUT12_15          157 
#define SEL_VOUTCLK2            158

#define USBPHY_CK_SEL           160 
#define SEL_USBPHY              160

#define HDMI_TST_SEL            161 
#define SEL_HDMI_TST            161

#define SF_SEL                  162
#define SEL_SFCS                162
#define SEL_SFCK                162
#define SEL_SFDI                162
#define SEL_SFDO                162

#define EXT_ACLK_SEL            168
#define SEL_APLL_CLK            168

#define SCNT_CK_SEL             172
#define SEL_SCNT_CK             172

#define MCIN_MPMCLK_SEL         175
#define SEL_MCIN_MPMCLK         175

#define MCIN_MPBCK_SEL          178 
#define SEL_MCIN_MPBCK          178

#define MCIN_MPLRCK_SEL         181 
#define SEL_MCIN_MPLRCK         181

#define VOUTCLK1_SEL            184 
#define SEL_VOUTCLK1            184

#define SPDATA1_SEL             186 
#define SEL_SPDATA1             186 

#define SPDATA2_SEL             188 
#define SEL_SPDATA2             188

#define SPDATA3_SEL             190 
#define SEL_SPDATA3             190

#define PROT_SEL                192 
#define SEL_PROT                192



/////////
#define MSSER_CLK_BS_SEL         260
#define SEL_MSBS                 260
#define SEL_MSCLK                260  

#define MS_BS_PRE_SEL            263

#define MSSER_SEL                264
#define SEL_MSD0                 264

#define MSPAL_SEL                268
#define SEL_MSD1                 268
#define SEL_MSD2                 268
#define SEL_MSD3                 268

#define SDSER_CLK_CMD_SEL        272
#define SEL_SDCLK                272
#define SEL_SDCMD                272

#define SDSER_SEL                276
#define SEL_SDD0                 276

#define SD1PAL_SEL               280
#define SEL_SDD1                 280

#define SD23PAL_SEL              284
#define SEL_SDD2                 284
#define SEL_SDD3                 284

#define SEL_FECTL_0              288


//PAD_PWMCTL @ 0X288
#define SEL_PWM_RELATCH          352

#define SEL_APLL_CLK_INV         353

#define ETLED_0_SEL              363
#define SEL_ETLED_0              363

#define SEL_HIN_SPMCLK2          368

#define SEL_HIN_SPBCK2           370

#define SEL_HIN_SPLRCK2          372

#define SEL_HIN_SPSDATA2         374

#define ETLED_1_SEL              376
#define SEL_ETLED_1              376

#define ETLED_2_SEL              379 
#define SEL_ETLED_2              379

#define MAX_PINMUX_SEL           382

#endif /* __MT8652_GPIO_PINMUX_H */

