/*
 * (C) Copyright 2003
 * Texas Instruments.
 * Kshitij Gupta <kshitij@ti.com>
 * Configuation settings for the TI OMAP Innovator board.
 *
 * (C) Copyright 2004
 * ARM Ltd.
 * Philippe Robin, <philippe.robin@arm.com>
 * Configuration for Integrator AP board.
 *.
 * See file CREDITS for list of people who contributed to this
 * project.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

#ifndef __CONFIG_H
#define __CONFIG_H

#define CONFIG_ARCH_MT85XX 1
#define CONFIG_MT85XX 1
#include <chip_ver.h>
#include <asm/arch/mt85xx.h>       /* get chip and board defs */
//#define CONFIG_CM1176JZ_S 1 /* CPU core is ARM1176JZ-S */
#include <upg_config.h>

#define CONFIG_FAST_BOOT 0
#define CONFIG_SYS_NO_FLASH                    1

#define CONFIG_SINGLE_CORE  0

#define CONFIG_CMDLINE_TAG	1	/* enable passing of ATAGs  */
//#define CONFIG_INITRD_TAG	1
//#define CONFIG_SETUP_MEMORY_TAGS	1
#define CONFIG_MISC_INIT_R	1	/* call misc_init_r during start up */


#undef CONFIG_INIT_CRITICAL
#define CONFIG_CM_INIT		1
#define CONFIG_CM_REMAP		1
#undef CONFIG_CM_SPD_DETECT
#define CONFIG_USE_IRQ		1

/*
 * mt85xx high level configuration options
 */
//#define CONFIG_BIM_TWO_WAY_WRITE

/*-----------------------------------------------------------------------
 * Serial Configuration
 */
#define CFG_MT85XX_SERIAL
#define CONFIG_CONS_INDEX	0
#define CONFIG_BAUDRATE		115200
#define CONFIG_SYS_BAUDRATE_TABLE	{ 9600, 19200, 38400, 57600, 115200 }

/*-----------------------------------------------------------------------
 * MMC Configuration
 */
//#define CONFIG_MMC     1

#ifdef CONFIG_MMC
#define CONFIG_CMD_MMC
#define CONFIG_GENERIC_MMC
#if (CONFIG_CHIP_VER_CURR >= CONFIG_CHIP_VER_MT8560)
#define CONFIG_MTK_MSDC
//#define CONFIG_EMMC_BOOT

#else
#define CONFIG_MTK_SD
#endif

#define CONFIG_CMD_EXT2
#define CONFIG_CMD_FAT
#define CONFIG_DOS_PARTITION
#endif

/*-----------------------------------------------------------------------
 * Commands
 * refer to config_cmd_all.h nad config_cmd_default.h
 */
#define CONFIG_CMD_MT85XX_BOOT
#define CONFIG_CMD_UPG
#define CONFIG_CMD_BDI		/* bdinfo			*/
#define CONFIG_CMD_FAT		/* FAT support			*/
#define CONFIG_CMD_MEMORY	/* md mm nm mw cp cmp crc base loop mtest */
#define CONFIG_CMD_MTDPARTS	/* mtd parts support		*/
#define CONFIG_CMD_NAND		/* NAND support			*/
#define CONFIG_CMD_USB		/* USB Support			*/
#define CONFIG_CMD_NET             /*  NET support      */
#define CONFIG_CMD_PING		/* ping support			*/

#define CONFIG_BOOTDELAY	0
//#define CONFIG_BOOTARGS		"root=/dev/mtdblock0 mem=32M console=ttyAM0 console=tty"
//#define CONFIG_BOOTARGS		"root=/dev/ram0 rw initrd=0x02800000,16M console=ttyMT0 mem=384M"
#define CONFIG_BOOTARGS		"noinitrd root=/dev/mtdblock7 ro "

#ifdef CONFIG_CMD_MT85XX_BOOT
#define CONFIG_BOOTCOMMAND	"mt85xx_boot nand"
#else
#define CONFIG_BOOTCOMMAND	"cp.b 0x80500000 0x2800000 0x800000;bootm 0x80300000"
#endif
//#define CONFIG_ZERO_BOOTDELAY_CHECK	/* check keypress when bootdelay = 0 */
#define CONFIG_ZERO_BOOTDELAY_CHECK

//Add Upgrade related default env variables
#if (CONFIG_CHIP_VER_CURR == CONFIG_CHIP_VER_MT8530)
#define CFG_UPG_BE_NAME     8530_linux_demo_dbg.bin
#elif (CONFIG_CHIP_VER_CURR == CONFIG_CHIP_VER_MT8550)
#if (CFG_BRANCH_NAME == 1)
#define CFG_UPG_BE_NAME    PANA_DVD.FRM
#else
#define CFG_UPG_BE_NAME     8550_linux_demo_dbg.bin
#endif
#elif (CONFIG_CHIP_VER_CURR == CONFIG_CHIP_VER_MT8555)
#define CFG_UPG_BE_NAME     8555_linux_demo_dbg.bin
#elif (CONFIG_CHIP_VER_CURR == CONFIG_CHIP_VER_MT8560)
#define CFG_UPG_BE_NAME     8560_linux_demo_dbg.bin
#elif (CONFIG_CHIP_VER_CURR == CONFIG_CHIP_VER_MT8561)
#define CFG_UPG_BE_NAME     8561_linux_demo_dbg.bin
#elif (CONFIG_CHIP_VER_CURR == CONFIG_CHIP_VER_MT8580)
#define CFG_UPG_BE_NAME     8580_linux_demo_dbg.bin
#endif
#define CFG_UPG_SUPPORT_FE  1
#define CFG_UPG_FE_NAME     DVD.bin
//#define CFG_UPG_USB_PATH    UPG
//Add Upgrade related default env variables end

#if CONFIG_FAST_BOOT
//#define CONFIG_SILENT_CONSOLE   /* enable silent startup	*/
#endif

/*-----------------------------------------------------------------------
 * Miscellaneous configurable options
 */
#define CFG_LONGHELP	/* undef to save memory	    */
#if (CONFIG_CHIP_VER_CURR == CONFIG_CHIP_VER_MT8530)
#define CONFIG_SYS_PROMPT	"mt8530_base # "	/* Monitor Command Prompt   */
#elif (CONFIG_CHIP_VER_CURR == CONFIG_CHIP_VER_MT8550)
#define CONFIG_SYS_PROMPT	"mt8550_base # "	/* Monitor Command Prompt   */
#elif (CONFIG_CHIP_VER_CURR == CONFIG_CHIP_VER_MT8555)
#define CONFIG_SYS_PROMPT	"mt8555_base # "	/* Monitor Command Prompt   */
#elif (CONFIG_CHIP_VER_CURR == CONFIG_CHIP_VER_MT8560)
#define CONFIG_SYS_PROMPT	"mt8560_base # "	/* Monitor Command Prompt   */
#elif (CONFIG_CHIP_VER_CURR == CONFIG_CHIP_VER_MT8561)
#define CONFIG_SYS_PROMPT	"mt8561_base # "	/* Monitor Command Prompt   */
#elif (CONFIG_CHIP_VER_CURR == CONFIG_CHIP_VER_MT8580)
#define CONFIG_SYS_PROMPT	"mt8580_base # "	/* Monitor Command Prompt   */
#endif
#define CONFIG_SYS_CBSIZE	1024		/* Console I/O Buffer Size  */
/* Print Buffer Size */
#define CONFIG_SYS_PBSIZE	(CONFIG_SYS_CBSIZE+sizeof(CONFIG_SYS_PROMPT)+16)
#define CONFIG_SYS_MAXARGS	16		/* max number of command args	*/
#define CFG_BARGSIZE	CONFIG_SYS_CBSIZE	/* Boot Argument Buffer Size	*/

#undef	CFG_CLKS_IN_HZ		/* everything, incl board info, in Hz */
#define CONFIG_SYS_LOAD_ADDR	0x7fc0	/* default load address */

/*-----------------------------------------------------------------------
 * Stack sizes
 *
 * The stack sizes are set up in start.S using the settings below
 */
#define CONFIG_STACKSIZE	(128*1024)	/* regular stack */
#ifdef CONFIG_USE_IRQ
#define CONFIG_STACKSIZE_IRQ	(4*1024)	/* IRQ stack */
#define CONFIG_STACKSIZE_FIQ	(4*1024)	/* FIQ stack */
#endif

/*-----------------------------------------------------------------------
 * Physical Memory Map
 */

/*  #include "../../board/mt5391/drv_lib/drv_inc/c_model.h" */
/*  #include "../../board/mt5391/drv_lib/drv_cust/drv_default.h" */

#define CONFIG_NR_DRAM_BANKS	1	/* we have 1 bank of DRAM */
#define PHYS_SDRAM_1		0x00000000	/* SDRAM Bank #1 */
//#define PHYS_SDRAM_1_SIZE	(128*1024*1024)

#define CFG_FLASH_BASE		0x28000000

/*-----------------------------------------------------------------------
 * FLASH and environment organization
 */

//#ifdef CC_NAND_BOOT
//#define CONFIG_ENV_IS_IN_NAND
//#define CONFIG_ENV_OFFSET		0x40000     // offset: 256KB
//#define CONFIG_ENV_SIZE		0x20000     // 128KB
//#else
//#define CFG_ENV_IS_IN_FLASH
//#define CONFIG_INFERNO

//#define CONFIG_ENV_IS_IN_NAND	1	/* use NAND for environment vars	*/
//#define CFG_ENV_IS_NOWHERE
//#define CFG_ENV_ADDR		0x28040000

#define CONFIG_ENV_IS_NOWHERE   1
#define CONFIG_ENV_SIZE		0x2000

//#endif

/////
////
// Meng-Chang Liu
///////
/*
 * IPL (Initial Program Loader, integrated inside CPU)
 * Will load first 4k from NAND (SPL) into cache and execute it from there.
 *
 * SPL (Secondary Program Loader)
 * Will load special U-Boot version (NUB) from NAND and execute it. This SPL
 * has to fit into 4kByte. It sets up the CPU and configures the SDRAM
 * controller and the NAND controller so that the special U-Boot image can be
 * loaded from NAND to SDRAM.
 *
 * NUB (NAND U-Boot)
 * This NAND U-Boot (NUB) is a special U-Boot version which can be started
 * from RAM. Therefore it mustn't (re-)configure the SDRAM controller.
 *
 * On 440EPx the SPL is copied to SDRAM before the NAND controller is
 * set up. While still running from cache, I experienced problems accessing
 * the NAND controller.	sr - 2006-08-25
 */
#define CFG_NAND_BOOT_SPL_SRC	0xfffff000	/* SPL location			*/
#define CFG_NAND_BOOT_SPL_SIZE	(4 << 10)	/* SPL size			*/
#define CFG_NAND_BOOT_SPL_DST	(CFG_OCM_BASE + (12 << 10)) /* Copy SPL here	*/
#define CFG_NAND_U_BOOT_DST	0x01000000	/* Load NUB to this addr	*/
#define CFG_NAND_U_BOOT_START	CFG_NAND_U_BOOT_DST /* Start NUB from this addr	*/
#define CFG_NAND_BOOT_SPL_DELTA	(CFG_NAND_BOOT_SPL_SRC - CFG_NAND_BOOT_SPL_DST)

/*
 * Define the partitioning of the NAND chip (only RAM U-Boot is needed here)
 */
#define CFG_NAND_U_BOOT_OFFS	(16 << 10)	/* Offset to RAM U-Boot image	*/
#define CFG_NAND_U_BOOT_SIZE	(384 << 10)	/* Size of RAM U-Boot image	*/

/*
 * Now the NAND chip has to be defined (no autodetection used!)
 */
#define CFG_NAND_PAGE_SIZE	(2048)		/* NAND chip page size		*/
#define CFG_NAND_BLOCK_SIZE	(256 << 10)	/* NAND chip block size		*/
#define CFG_NAND_PAGE_COUNT	(128)		/* NAND chip page count		*/
#define CFG_NAND_BAD_BLOCK_POS	(1)		/* Location of bad block marker	*/
#undef CFG_NAND_4_ADDR_CYCLE			/* No fourth addr used (<=32MB)	*/
#define CFG_NAND_YAFFS1_NEW_OOB_LAYOUT
#define CFG_NAND_YAFFS_WRITE

#define CONFIG_CMD_UBI
#define CONFIG_CMD_MTDPARTS
#define CONFIG_MTD_DEVICE
#define CONFIG_MTD_PARTITIONS
#define CONFIG_RBTREE

#ifdef CONFIG_ENV_IS_IN_NAND
/*
 * For NAND booting the environment is embedded in the U-Boot image. Please take
 * look at the file board/amcc/sequoia/u-boot-nand.lds for details.
 */
#define CONFIG_ENV_SIZE		CFG_NAND_BLOCK_SIZE
#define CONFIG_ENV_OFFSET		(CFG_NAND_U_BOOT_OFFS + CONFIG_ENV_SIZE)
#define CFG_ENV_OFFSET_REDUND	(CONFIG_ENV_OFFSET + CONFIG_ENV_SIZE)
#endif

#if (CONFIG_CHIP_VER_CURR == CONFIG_CHIP_VER_MT8530)
#define CONFIG_MTD_NAND_MT8530
#elif (CONFIG_CHIP_VER_CURR == CONFIG_CHIP_VER_MT8550)
#define CONFIG_MTD_NAND_MT8550
#elif (CONFIG_CHIP_VER_CURR == CONFIG_CHIP_VER_MT8555)
#define CONFIG_MTD_NAND_MT8555
#elif (CONFIG_CHIP_VER_CURR == CONFIG_CHIP_VER_MT8560)
#define CONFIG_MTD_NAND_MT8560
#elif (CONFIG_CHIP_VER_CURR == CONFIG_CHIP_VER_MT8561)
#define CONFIG_MTD_NAND_MT8561
#elif (CONFIG_CHIP_VER_CURR == CONFIG_CHIP_VER_MT8580)
#define CONFIG_MTD_NAND_MT8580
#endif

////
// Meng-Chang Liu
///


//#define PHYS_FLASH_SIZE		0x01000000	/* 16MB */
#define CONFIG_SYS_MAX_FLASH_BANKS	1		/* max number of memory banks */
#define PHYS_FLASH_1		(CFG_FLASH_BASE)

/* timeout values are in ticks */
#define CFG_FLASH_ERASE_TOUT	(2*CONFIG_SYS_HZ)	/* Timeout for Flash Erase */
#define CFG_FLASH_WRITE_TOUT	(2*CONFIG_SYS_HZ)	/* Timeout for Flash Write */
#define CONFIG_SYS_MAX_FLASH_SECT	    256

/*
 * Size of malloc() pool
 */
//#define CONFIG_SYS_MALLOC_LEN  (0x06000000) /* 128M */
#define CONFIG_SYS_MALLOC_LEN  (0x03000000) /* 96M->48M */
#define CONFIG_SYS_GBL_DATA_SIZE	128	/* size in bytes reserved for initial data */

/*-----------------------------------------------------------------------
 * Net driver interface
 */
//#define CONFIG_NET_MULTI
#define CONFIG_DRIVER_RTL8150
#define CONFIG_DRIVER_AX88772
#define CONFIG_DRIVER_PEGASUSII
#define CONFIG_DRIVER_MMAC85XX
/*-----------------------------------------------------------------------
 * Network setting
 */
#define CONFIG_IPADDR       172.22.82.167
#define CONFIG_GATEWAYIP    172.22.82.254
#define CONFIG_NETMASK      255.255.255.0

#define CONFIG_SERVERIP     172.21.69.23
#define CONFIG_ETHADDR      00:0C:E7:00:00:00
#define CONFIG_ENV_OVERWRITE
/*-----------------------------------------------------------------------
 * TFTP load address
 */
#define CONFIG_LOADADDR	0x2000000	// TFTP store address


/*-----------------------------------------------------------------------
 * There are various dependencies on the core module (CM) fitted
 * Users should refer to their CM user guide
 * - when porting adjust u-boot/Makefile accordingly
 *   to define the necessary CONFIG_ s for the CM involved
 * see e.g. integratorcp_CM926EJ-S_config
 */
#include "armcoremodule.h"


#define CONFIG_DOS_PARTITION
#define CONFIG_SUPPORT_VFAT

/* USB */
#define CONFIG_USB_STORAGE
#define CONFIG_USB_MTKHCD
#define LITTLEENDIAN            1       /* used by usb.h  */


/*
 *  Board NAND Info.
 */
#define CONFIG_SYS_NAND_BASE 0x7001E000
#define CFG_NAND_ADDR 0x04000000  /* physical address to access nand at CS0*/

#define CONFIG_SYS_MAX_NAND_DEVICE 1	/* Max number of NAND devices */
#define CONFIG_SYS_NAND_MAX_CHIPS 2

#define LARGE_NAND_PAGESIZE
#ifdef LARGE_NAND_PAGESIZE
    #define SECTORSIZE          2048
    #define ADDR_ID             1
    #define ADDR_COLUMN         2
    #define ADDR_PAGE           2
    #define ADDR_COLUMN_PAGE    4
    #define SCANBLOCK_POS       62
    #define BADBLOCK_POS        0
    #define BLOCK_SCAN_FLAG     0x5A
#else
    #define SECTORSIZE          512
    #define ADDR_ID             1
    #define ADDR_COLUMN         1
    #define ADDR_PAGE           3  
    #define ADDR_COLUMN_PAGE    4  
    #define BLOCK_SCAN_POS      14
    #define BADBLOCK_POS        5/*15*/ 
    #define BLOCK_SCAN_FLAG     0x5A
#endif

#define NAND_ChipID_UNKNOWN 0x00
#define NAND_MAX_FLOORS     1
#define NAND_MAX_CHIPS      1

#define NAND_OP_NONE                0
#define NAND_OP_READID              1
#define NAND_OP_READSTATUS          2
#define NAND_OP_READPAGE            3
#define NAND_OP_WRITEPAGE           4
#define NAND_OP_READSPARE           5
#define NAND_OP_WRITESPARE          6

#define LARGE_NAND_BOOT

/*
 * EEPROM 
 */
#define CFG_I2C_EEPROM_ADDR_LEN     2
#define CFG_I2C_EEPROM_ADDR     SYSTEM_EEPROM_ADDRESS
#define CFG_EEPROM_SIZE			SYSTEM_EEPROM_SIZE  	/* size in bytes            */
#define CFG_EEPROM_PAGE_WRITE_BITS  2       // (2^CFG_EEPROM_PAGE_WRITE_BITS) bytes
#define CFG_EEPROM_PAGE_WRITE_DELAY_MS 20   //delay  (CFG_EEPROM_PAGE_WRITE_DELAY_MS) ms
#define CFG_SYS_CLK (27*1000*1000)
#define CFG_BUS_CLK  (100*1000)
#define CFG_EEPROM_WREN
//#define CFG_ENV_IS_IN_EEPROM
//#define DEBUG_I2C

#define CONFIG_MT85XX_GPIO

/* enable I2C and select the hardware/software driver */
#undef  CONFIG_HARD_I2C			/* I2C with hardware support	*/
#undef  CONFIG_SOFT_I2C
#define CONFIG_SYS_I2C_SPEED		30000	/* I2C speed and slave address	*/
#define CONFIG_SYS_I2C_SLAVE		0x7F

#if (CONFIG_CHIP_VER_CURR == CONFIG_CHIP_VER_MT8560) || (CONFIG_CHIP_VER_CURR == CONFIG_CHIP_VER_MT8561) || (CONFIG_CHIP_VER_CURR == CONFIG_CHIP_VER_MT8580)
#undef  CONFIG_SOFT_I2C
#endif


#define CONFIG_EXTERNAL_MCU 0

#define CONFIG_MT85XX_VFD

#define CONFIG_UBOOT_CUSTOM_0     1


#endif	/* __CONFIG_H */

